(defun UDIST (bit kwd msg def bpt / inp)
     (if def
          (setq msg (strcat "\n" msg "<" (rtos def) ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1)) 
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp
          (if bpt
               (getdist msg bpt)
               (getdist msg)
          )
     )
     (if inp inp def)
)
;-------------------------------------------------------------------------
(defun UKWORD (bit kwd msg def / inp)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1))
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp (getkword msg))
     (if inp inp def)
)
;-------------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               inp (getstring spflag msg)
               inp (if (= inp "") def inp)
          )
          (progn
               (if (= " " (substr msg (strlen msg) 1))
                    (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
                    (setq msg (strcat "\n" msg ": "))
               )
               (if (= bit 1)
                    (while (= "" (setq inp (getstring spflag msg)))
                         (prompt "\nInvalid String.")
                    )
                    (setq inp (getstring spflag msg))
               )
          )
     )
     inp
)
;-------------------------------------------------------------------------
(defun UINT (bit kwd msg def / inp)
     (if def
          (setq msg (strcat "\n" msg "<" (itoa def) ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1)) 
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp (getint msg))
     (if inp inp def)
)
;-------------------------------------------------------------------------
(defun UREAL (bit kwd msg def / inp)
     (if def
          (setq msg (strcat "\n" msg "<" (rtos def 2) ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1)) 
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp (getreal msg))
     (if inp inp def)
)
;-------------------------------------------------------------------------
(defun UPOINT (bit kwd msg def bpt / inp)
     (if def
          (setq pts (strcat 
               (rtos (car def)) "," (rtos (cadr def))
               (if
                    (and (caddr def) (= 0 (getvar "FLATLAND")))
                    (strcat "," (rtos (caddr def))) 
                    ""
               )
          )
          msg (strcat "\n" msg "<" pts ">: ")
          bit (* 2 (fix (/ bit 2)))
     ) 
     (if (= " " (substr msg (strlen msg) 1))
          (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
          (setq msg (strcat "\n" msg ": "))
     )
)
(initget bit kwd)
(setq inp
     (if bpt
          (getpoint msg bpt)
          (getpoint msg)
     )
)
(if inp inp def)
) 
;-------------------------------------------------------------------------
(defun UANGLE (bit kwd msg def bpt / inp)
(if def
     (setq msg (strcat "\n" msg "<" (angtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
     )
     (if (= " " (substr msg (strlen msg) 1))
          (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
          (setq msg (strcat "\n" msg ": "))
     )
)
(initget bit kwd)
(setq inp
     (if bpt
          (getangle msg bpt)
          (getangle msg)
     )
)
(if inp inp def)
)
;-------------------------------------------------------------------------
(defun UENTSL (bit kwd msg def / inp ss)
(if (and msg (/= msg "")) nil (setq msg "Select object"))
(if (and def (/= def ""))
     (setq msg (strcat "\n" msg "<" def ">: ")
          bit 0
     )
     (if (= " " (substr msg (strlen msg) 1))
          (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
          (setq msg (strcat "\n" msg ": "))
     )
)
(initget bit kwd)
(setq inp (getpoint msg))
(cond
     ( (= (type (setq kwd (if inp inp def))) 'STR)
          kwd
     )
     ( (not inp) nil )
     ( (setq ss (ssget inp))
          (if ss (list (ssname ss 0) inp) nil)
     )
) 
)  
;-------------------------------------------------------------------------
(defun SSUNION (ss1 ss2 / hilite ss3)
(setq hilite (getvar "HIGHLIGHT"))
(setvar "HIGHLIGHT" 0)
(command "SELECT" ss1 ss2 "")
(setq ss3 (ssget "P"))
(setvar "HIGHLIGHT" hilite)
ss3
)
;-------------------------------------------------------------------------
(defun SSDIFF (ss1 ss2 / hilite ss3)
(setq hilite (getvar "HIGHLIGHT"))
(setvar "HIGHLIGHT" 0)
(command "SELECT" ss1 "R" ss2 "")
(setq ss3 (ssget "P"))
(setvar "HIGHLIGHT" hilite)
ss3
)
;-------------------------------------------------------------------------
(defun SSINTER (ss1 ss2 / count count1 count2 smax smax1 
ssmax2 more less name / hilite ss3)
(setq count 0
count1 0
count2 0
smax1 (sslength ss1)
smax2 (sslength ss2)
ss3 (ssadd)
)
(if (>= count1 count2)
(setq more ss1 less ss2 smax smax1)
(setq more ss2 less ss1 smax smax2)
)
(while (< count smax)
(setq name (ssname more count))
(if (ssmemb name less)
     (ssadd name ss3)
)
(setq count (1+ count))
)
ss3
)
;-------------------------------------------------------------------------
(defun DXF (code elist)
(cdr (assoc code elist))
)
;-------------------------------------------------------------------------
(defun RAD (degree)
(setq radian (/ (* degree 3.1416) 180))
radian
)
;-------------------------------------------------------------------------
(defun DEG (Rad)
(setq degree (/ (* rad 180) 3.1416))
degree
)
;-------------------------------------------------------------------------
(defun OSMODE ( mode )
( if (= mode 1) 
(setvar "OSMODE" #OSMODE) 
(progn
     (setq #OSMODE (getvar "OSMODE"))
     (setvar "OSMODE" 0)
)
)
)
;-------------------------------------------------------------------------

(defun u_ssget ( / ssl  sset nsset temp ed )
(setq sset (ssget)
ssl (sslength sset) 
nsset (ssadd)
)
(print ssl) (princ "entities found. ")  

(princ "\nVerifying the selected entities -- please wait. ")
(while (> ssl 0)
(progn
     (setq temp (ssname sset (setq ssl (1- ssl))))
     (setq ed (entget temp))
     (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
)
)
(setq ssl (sslength nsset)
sset nsset
)
(print ssl) (princ "TEXT entities found. ")
(princ)
(sset)
) ;defun u_ssget
