
(defun DXF (code elist)
  (cdr (assoc code elist))
)

(defun CDXF (tt elist)
  (car (nth tt elist))
)
;CDXF - xac dinh thu tu cua tieu danh sach

(defun xdtt (code elist)
(setq i 0)
(while (/= code (cdxf i elist))
;(progn
  (setq i (+ 1 i))
);while
)

(defun RAD (degree)
  (setq radian (/ (* degree pi) 180))
  radian
)

(defun DEG (Rad)
  (setq degree (/ (* rad 180) pi))
  degree
)

(defun tangent (Rad)
  (setq tang (/ (sin rad) (cos rad)))
  tang
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun text_u_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities ... please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "TEXT entities found. ")
  (princ)
  (print)
);defun u_ssget


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun block_u_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "INSERT") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "BLOCK entities found. ")
  (princ)
  (print)
);defun block_u_ssget

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(princ "\nTO  : To oblique or straighten up TEXT entities")
(princ)

(defun c:TO( / sset ssl temp ed old new )
(text_u_ssget)
(setq ssl (sslength sset))
(if (> ssl 0) 
  (setq ob_angle (getreal "New oblique angle of the selected texts : "))
 )
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))

       (setq old (cons 51 (DXF 51 ed))
             new (cons 51 (tangent (rad ob_angle)))
             ed (subst new old ed)
           )
      (entmod ed)  
      )  
  )


 (princ)
);defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(princ "\nTT2 : To update TEXT to V22 style and current size")
(princ)

(defun c:TT2( / sset ssl temp ed old new )
(text_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
         (progn
           (setq old (cons 7 (DXF 7 ed))
                 sty "V22"
                 new (cons 7 sty)
                 ed (subst new old ed)
            )
           (setq old (cons 40 (DXF 40 ed))
                 size (* 2 scale)
                 new (cons 40 size)
                 ed (subst new old ed)
           )
      )  

      (entmod ed)  
    )
  )
 (princ)
);defun TT2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(princ "\nTT5 : To update TEXT to V5 style and current size")
(princ)

(defun c:TT5( / sset ssl temp ed old new )
(text_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
         (progn
           (setq old (cons 7 (DXF 7 ed))
                 sty "V5"
                 new (cons 7 sty)
                 ed (subst new old ed)
            )
           (setq old (cons 40 (DXF 40 ed))
                 size (* 4 scale)
                 new (cons 40 size)
                 ed (subst new old ed)
           )
      )  

      (entmod ed)  
    )
  )
 (princ)
);defun TT5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(princ "\nVA  : To align TEXT entities horizontally")
(princ)

(defun c:VA( / sset ssl temp ed old new )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
(print)
;(text_u_ssget)
(setq ssl (sslength sset))
(if (> ssl 0) 
(setq pt1 (getpoint "New aligned point of the selected entities : ")))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
;;;TEXT
     (if (= (DXF 0 ed) "TEXT")
      (progn
       (setq old (nth (xdtt 10 ed) ed)
             new (list (nth 0 old) (nth 1 old) (cadr pt1) (nth 3 old))
             ed (subst new old ed)
           )
      (entmod ed)  
      )  
  )

;;;BLOCK
     (if (= (DXF 0 ed) "INSERT")
      (progn
        (setq old (nth (XDTT 10 ED) ed))
        (setq new (list (nth 0 old) (nth 1 old) (cadr pt1) (nth 3 old)))
        (setq y1 (nth 2 old))
        (setq ed (subst new old ed))
        (entmod ed)  
        (setq en (entnext (DXF -1 ed)))
        (while (/= (DXF 0 (entget en)) "SEQEND")
          (progn
            (setq ed (entget en))
            (setq old (nth (XDTT 10 ED) ed))
            (setq y2 (nth 2 old))
            (setq dy (- y2 y1))
            (setq new (list (nth 0 old) (nth 1 old) (+ (cadr pt1) dy) (nth 3 old)))
            (setq ed (subst new old ed))
            (entmod ed)  
           (setq en (entnext en))
          );progn
        );while
      (entupd en)
      );progn
    );if BLOCK
 )
)

(setq pt1 nil)
 (princ)
);defun

;;;;;end of old



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(princ "\nCA  : To switch between UPCASE and LOWCASE of TEXT entities")
(princ)

(defun c:CA( / sset ssl temp ed old new )
(text_u_ssget)
(initget 1 "U u L l")
(setq ssl (sslength sset))
(if (> ssl 0) 
 (setq sw (getkword "New case of the selected texts [U/L] : ")))
  (while (> ssl 0)
 ( if (or (= sw "U") (= sw "u"))
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))

       (setq old (cons 1 (DXF 1 ed))
             new (cons 1 (strcase (DXF 1 ed)))
             ed (subst new old ed)
           )
      (entmod ed)  
      )  
  );if
 ( if (or (= sw "l") (= sw "L"))
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))

       (setq old (cons 1 (DXF 1 ed))
             new (cons 1 (strcase (DXF 1 ed) T))
             ed (subst new old ed)
           )
      (entmod ed)  
      )  
  );if
);while

 (princ)
);defun CA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(princ "\nBC  : To change the scale of the selected blocks")
(princ)

(defun c:BC( / sset ssl temp ed old new )
(block_u_ssget)
(setq ssl (sslength sset))
(if(> ssl 0) (setq sca (getreal "\nInput new scale for selected attdefs : ")))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
         (progn
           (setq old (cons 41 (DXF 41 ed))
                 new (cons 41 (* sca (DXF 41 ed)))
                 ed (subst new old ed)
            )
           (setq old (cons 42 (DXF 42 ed))
                 new (cons 42 (* sca (DXF 42 ed)))
                 ed (subst new old ed)
           )
          (setq x1 (nth 0 (DXF 10 ed)))
          (setq y1 (nth 1 (DXF 10 ed)))
      )  
       (entmod ed)  
        (setq en (entnext (DXF -1 ed)))
        (while (/= (DXF 0 (entget en)) "SEQEND")
          (progn
            (setq ed (entget en))
            (setq old (cons 40 (DXF 40 ed))
                  new (cons 40 (* sca (DXF 40 ed)))
                  )  
            (setq ed (subst new old ed))

            (setq x2 (nth 0 (DXF 11 ed)))
            (setq dx (- x2 x1))
            (setq y2 (nth 1 (DXF 11 ed)))
            (setq dy (- y2 y1))

           (setq old (nth (XDTT 11 ED) ed))
           (setq new (list (nth 0 old) (+ x1 (* sca dx)) (+ y1 (* sca dy)) (nth 3 old)))
                 
            (setq ed (subst new old ed))

            (entmod ed)  
            (setq en (entnext en))
          );progn
        );while

        (entupd en)  

    );progn
  );while
 (princ)
);defun BC
(princ)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
