(prompt "\nLoading CAD Utilities Written by NTTLe XD91CD Ver 1.1 ")
(prompt "\nThank you for using these utilities. Please donot change!")
(defun NS (x1 y1 x2 y2 x)
  (+ y1 (* (- x x1) (/ (float (- y1 y2)) (float (- x1 x2)))))
)
(defun USTR (bit msg def spflag / inp nval)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          inp (getstring spflag msg)
          inp (if (= inp "") def inp)
    )
    (progn
      (if (= " " (substr msg (strlen msg) 1))
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
        (setq msg (strcat "\n" msg ": "))
      )
      (if (= bit 1)
        (while (= "" (setq inp (getstring spflag msg)))
           (prompt "\nInvalid String.")
        )
        (setq inp (getstring spflag msg))
      )
    )
  )
  inp
)
(defun UINT (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (itoa def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getint msg))
  (if inp inp def)
)
(defun UREAL (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def 2) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getreal msg))
  (if inp inp def)
)
(defun CMDECH (mode)
  (if (= mode 1)
    (setvar "CMDECHO" 0)
    (setvar "CMDECHO" 1) 
  )
  (graphscr)
  (princ)
)
(defun DXF (code elist)
  (cdr (assoc code elist))
)
(defun ETOS (arg / file)
  (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
  (setq file (open "$" "w"))
  (princ arg file)
  (close file)
  (setq file (open "$" "r"))
  (setq arg (read-line file))
  (close file)
  (close (open "$" "w"))
  arg
)  
(defun fopen ( fname mode msg / fh )
  (setq fh (open fname mode))
  (while (= fh nil)
    (progn
       (Prompt (strcat "\nFile " msg " Not Found !"))
       (setq fname (USTR 1 (strcat "\nInput " msg " Again : ") nil T)
             fh (open fname mode)
       ) 
    )
  )
  fh
)
(defun round (number accuracy)
  (atof (rtos number 2 accuracy))
)

(prompt "\nBDNL: Ve Bieu Do Noi Luc Cho Khung phang tu FILE so lieu cua FEAP")

(defun c:BDNL( / fh1 fh2 NODES ELEMENTS temp pt0 pt1 pt2 pt3 pt4
                 mc V_scale loai i sonut sophantu mid )
  (setq f1 (USTR 1 "Nhap Ten File So Lieu (NODE, ELEMENT)" f1 T)
        fh1 (fopen f1 "r" f1)
        f2 (USTR 1 "Nhap Ten File So Lieu (FEAP)" f2 T)
        fh2 (fopen f2 "r" f2)
        loai (UINT 4 "" " Luc Doc (0), Luc Cat (1), Moment (2) " 2)
        mc (UINT 4 "" " So mat cat moi tiet dien " 2)
        V_scale (UREAL 4 "" " Ti Le Dung " 0.02)
  )

  (command "STYLE" "2" "ROMANS" "0.3" "" "" "" "" "")

  (command "LAYER" "M" "NODES" "C" "3" "NODES" "")  
  (command "LAYER" "M" "ELEMENTS" "C" "1" "ELEMENTS" "")  
  (command "LAYER" "M" "BDNL" "C" "1" "BDNL" "")  
  (command "LAYER" "M" "TEXT" "C" "4" "TEXT" "")  

;Ve khung phang
  (setq temp (read (strcat "(" (read-line fh1) ")"))
        sonut (nth 0 temp)
        i 0
  )
;Danh so nut
  (command "LAYER" "S" "NODES" "")
  (while (< i sonut)
     (progn
        (setq temp (read (strcat "(" (read-line fh1) ")"))
              NODES (append NODES (list (list (nth 1 temp) (nth 2 temp) )))
        )
        (setq pt0 (nth i NODES)
              pt1 (polar pt0 0.7854 0.25)
              pt2 (polar pt0 2.35619 0.25)
              pt3 (polar pt0 -2.35619 0.25)
              pt4 (polar pt0 -0.7854 0.25)
        )
        (command "TEXT" "J" "BL" pt0 "0" (etos (nth 0 temp)))
        (command "PLINE" pt1 pt2 pt3 pt4 "c")
        (setq i (+ 1 i))
     )
  );while
; Ve phan tu
  (setq temp (read (strcat "(" (read-line fh1) ")"))
        sophantu (nth 0 temp)
        i 0
  )
  (while (< i sophantu)
    (progn   
       (command "LAYER" "S" "0" "")  
       (setq temp (read (strcat "(" (read-line fh1) ")"))
             ELEMENTS (append ELEMENTS (list (list (nth 1 temp) (nth 2 temp) )))
             pt1 (nth (- (nth 1 temp) 1) NODES)
             pt2 (nth (- (nth 2 temp) 1) NODES)
             mid (list (/ (+ (car pt1) (car pt2)) 2.0) (/ (+ (cadr pt1) (cadr pt2)) 2.0) )
       )
       (command "LINE" pt1 pt2 "")
       (command "LAYER" "S" "ELEMENTS" "")  
       (command "TEXT" "J" "BC" mid (/ (* (angle pt1 pt2) 180) PI) (etos (nth 0 temp)))
       (setq i (+ 1 i))
    );progn        
  );while

; Ve bieu do noi luc
(setq i 0)


(setq ele0 1)
(setq pt0 (nth (- (nth 0 (nth 0 ELEMENTS)) 1) NODES))

(while (< i (* sophantu mc))
  (progn
    (command "LAYER" "S" "BDNL" "")
    (setq temp (read (strcat "(" (read-line fh2) ")"))
          ele (nth 0 temp)
          sec (nth 1 temp)
    )
    (if (= loai 0) (setq tungdo (* (nth 2 temp) V_scale)))
    (if (= loai 1) (setq tungdo (* (nth 3 temp) V_scale)))
    (if (= loai 2) (setq tungdo (* (nth 4 temp) V_scale)))

    (setq pt1 (nth (- (nth 0 (nth (- ele 1) ELEMENTS)) 1) NODES))
    (if (/= ele0 ele) 
       (progn
         (command "LINE" pt0 pt2 "")
         (setq pt0 pt1 ele0 ele )
       )
    )
    (setq pt2 (nth (- (nth 1 (nth (- ele 1) ELEMENTS)) 1) NODES)
          ang (angle pt1 pt2)
          pt4 (polar pt1 ang sec) 
          pt3 (polar pt4 (- ang (/ PI 2)) tungdo)
    )
    (command "LINE" pt0 pt3 pt4 "")
    (command "LAYER" "S" "TEXT" "")
    (if (> tungdo 0) 
      (command "TEXT" "J" "BL" pt4 (- (/ (* ang 180) PI) 90) (strcat (rtos (/ tungdo V_scale) 2 2) " "))
      (command "TEXT" "J" "BR" pt4 (- (/ (* ang 180) PI) 90) (strcat (rtos (/ tungdo V_scale) 2 2) " "))
    )
  (setq pt0 pt3)

    (setq i (+ 1 i))
  );progn
);while
(command "LINE" pt0 pt2 "")
(close fh1)
(close fh2)
);DEFUN
;;;;;;;;;;;;;;;;;;;;
(prompt "\n INPUT : Nhap toa do nut tu SCREEN")
(DEFUN C:INPUT( / i fh1 pt0 pt1 str)
(setq f1 (USTR 1 "Nhap Ten File nut" nil T)
      fh1 (fopen f1 "w" f1)
      sonut (UINT 4 "" "So nut " nil)
      i 1
      pt0 (list 0 0)
)
(write-line (etos sonut) fh1)
(while (<= i sonut)
  (progn
     (setq str (strcat "\nNhap toa do nut so < " (etos i) " >")
           pt1 (getpoint str pt0)
           pt0 pt1
           str (strcat (etos i) "\t" (rtos (car pt1) 2 3) "\t" (rtos (cadr pt1) 2 3))
     )
     (command "TEXT" "J" "BR" pt1 "0" (strcat (etos i) " "))
     (write-line str fh1)
     (setq i (+ i 1))
  )
);while
(close fh1)
);defun
