(defun DXF (code elist)
  (cdr (assoc code elist))
)
;-----------------------------------------------------------------
(prompt "\nCh : To change entities to given layer")

(setq dlg_post '(-1 -1))

(defun c:ch ( / lalist ltlist clist la lt idx )

  (setq dcl_id (load_dialog "change.dcl"))  	
  (if (< dcl_id 0) (exit))   

  ; Set up dialog list box of layer
  (setq temp (tblnext "layer" T))
  (while (/= temp nil)
    (setq la (DXF 2 temp)
          lalist (cons la lalist)
          temp (tblnext "layer")
    )
  )
  (setq lalist (reverse lalist))

  ; Set up dialog list box of linetype
  (setq temp (tblnext "ltype" T))
  (while (/= temp nil)
    (setq lt (DXF 2 temp)
          ltlist (cons lt ltlist)
          temp (tblnext "ltype")
    )
  )

  ; Set up dialog list box of color
  (setq clist '("255"))
  (setq idx 254)
  (while (> idx 7) 
    (setq clist (cons (itoa idx) clist))
    (setq idx (1- idx))
  )
  (setq clist (cons "White" clist))
  (setq clist (cons "Magenta" clist))
  (setq clist (cons "Blue" clist))
  (setq clist (cons "Cyan" clist))
  (setq clist (cons "Green" clist))
  (setq clist (cons "Yellow" clist))
  (setq clist (cons "Red" clist))

  (setq what_next 5
        t1 "1" t2 "1" t3 "1"
        p1 "0" p2 "0" p3 "0" p4 "0"
        tx1 "" tx2 ""
  )
  (while (< 2 what_next)             
      (if (not (new_dialog "changedlg" dcl_id)) (exit))

      (start_list "player")
      (mapcar 'add_list lalist)
      (end_list)

      (start_list "ptola")
      (mapcar 'add_list lalist)
      (end_list)

      (start_list "pltype")
      (mapcar 'add_list ltlist)
      (end_list)

      (start_list "pcolor")
      (mapcar 'add_list clist)
      (end_list)

      (set_tile "tlayer" t1)
      (set_tile "tltype" t2)     
      (set_tile "tcolor" t3)    

      (set_tile "player" p1)
      (set_tile "pltype" p2)     
      (set_tile "pcolor" p3)    
      (set_tile "ptola" p4)    

      (set_tile "text1" tx1)    
      (set_tile "text2" tx2)    
       
      (ftlayer t1)
      (ftltype t2)
      (ftcolor t3)

      (action_tile "tlayer" "(ftlayer $value)")
      (action_tile "tltype" "(ftltype $value)")     
      (action_tile "tcolor" "(ftcolor $value)")    
      (action_tile "tdimention" "(ftdimention $value)")    

      (action_tile "player" "(fplayer $value)")
      (action_tile "pltype" "(fpltype $value)")     
      (action_tile "pcolor" "(fpcolor $value)")    
      (action_tile "ptola" "(fptola $value)")    

      (action_tile "select"    "(done_dialog 3)")
      (action_tile "filter"    "(ffilter)")
      (action_tile "accept"      "(done_dialog 0)")
      (action_tile "cancel"      "(done_dialog 0)")
    
      (setq what_next (start_dialog))   ; Throw up the dialogue.

      (if (= what_next 3)
         (progn
            (setq sset nil) 
            (setq sset (ssget))
            (if sset
               (setq len (sslength sset)
                     tx1 (rtos len 2 0)
               )
               (setq tx1 "0")
            ) 
         )
      )
    
   );while

  (unload_dialog dcl_id)                   	

  (fok)

  (princ)
);defun
;-----------------------------------------------------------------
(defun ffilter ( / la lt nsset temp ed ssl )
  (if (= sset nil) ( (prompt "\nSelect objects first") (exit)))
  (setq ssl (sslength sset)
        fsset (ssadd)
  )

  (cond
    ((AND (= t1 "1") (/= t2 "1") (/= t3 "1")) ; case 1 (1 0 0)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (= (DXF 8 ed) (nth (atoi p1) lalist)) (ssadd temp fsset))
         )
       )
    );case1
    ((AND (/= t1 "1") (= t2 "1") (/= t3 "1")) ; case 2 (0 1 0)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (= (DXF 6 ed) (nth (atoi p2) ltlist)) (ssadd temp fsset))
         )
       )
    );case2
    ((AND (/= t1 "1") (/= t2 "1") (= t3 "1")) ; case 3 (0 0 1)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (= (DXF 62 ed) (+ (atoi p3) 1)) (ssadd temp fsset))
         )
       )
    );case3
    ((AND (= t1 "1") (= t2 "1") (/= t3 "1")) ; case 4 (1 1 0)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (AND (= (DXF 8 ed) (nth (atoi p1) lalist))
                    (= (DXF 6 ed) (nth (atoi p2) ltlist))
               )
               (ssadd temp fsset)
           )
         )
       )
    );case4

    ((AND (= t1 "1") (/= t2 "1") (= t3 "1")) ; case 5 (1 0 1)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (AND (= (DXF 8 ed) (nth (atoi p1) lalist))
                    (= (DXF 62 ed) (+ (atoi p3) 1))
               )
               (ssadd temp fsset)
           )
         )
       )
    );case5

    ((AND (/= t1 "1") (= t2 "1") (= t3 "1")) ; case 6 (0 1 1)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (AND (= (DXF 6 ed) (nth (atoi p2) ltlist))
                    (= (DXF 62 ed) (+ (atoi p3) 1))
               )
               (ssadd temp fsset)
           )
         )
       )
    );case6

    ((AND (= t1 "1") (= t2 "1") (= t3 "1")) ; case 7 (1 1 1)
       (while (> ssl 0)
         (progn
           (setq temp (ssname sset (setq ssl (1- ssl))))
           (setq ed (entget temp))
           (if (AND (= (DXF 8 ed) (nth (atoi p1) lalist))
                    (= (DXF 6 ed) (nth (atoi p2) ltlist))
                    (= (DXF 62 ed) (+ (atoi p3) 1))
               )
               (ssadd temp fsset)
           )
         )
       )
    );case7

  );cond
  (setq tx2 (rtos (sslength fsset) 2 0))
  (set_tile "text2" tx2)

);defun
;-----------------------------------------------------------------
(defun ftlayer ( value )
  (setq t1 value)
  (if (= value "1")
     (mode_tile "player" 0)
     (mode_tile "player" 1)
  )
)
;-----------------------------------------------------------------
(defun ftltype ( value )
  (setq t2 value)
  (if (= value "1")
     (mode_tile "pltype" 0)
     (mode_tile "pltype" 1)
  )
)
;-----------------------------------------------------------------
(defun ftcolor ( value )
  (setq t3 value)
  (if (= value "1")
     (mode_tile "pcolor" 0)
     (mode_tile "pcolor" 1)
  )
)
;-----------------------------------------------------------------
(defun ftdimention ( value )
  (setq t4 value)
)
;-----------------------------------------------------------------
(defun fplayer ( value )
  (setq p1 value)
)
;-----------------------------------------------------------------
(defun fpltype ( value )
  (setq p2 value)
)
;-----------------------------------------------------------------
(defun fpcolor ( value )
  (setq p3 value)
)
;-----------------------------------------------------------------
(defun fptola ( value )
  (setq p4 value)
)
;-----------------------------------------------------------------
(defun fok ( / la ssl temp ed old new )
   (setq la (nth (atoi p4) lalist))
   (setq ssl (sslength fsset))

   (while (> ssl 0)
      (progn
         (setq temp (ssname fsset (setq ssl (1- ssl))) ; Change LAYER
               ed (entget temp)
               old (cons 8 (dxf 8 ed))
               new (cons 8 la)
               ed (subst new old ed)
         ) 
         (entmod ed)          

         (setq old (dxf 62 ed)) ; Change COLOR
         (if (/= old nil)
            (progn
               (setq old (cons 62 old)
                     new (cons 62 256)
                     ed (subst new old ed)
               )
            )
         )
         (entmod ed)          

         (setq old (dxf 6 ed)) ; Change LTYPE
         (if (/= old nil)
            (progn
               (setq old (cons 6 old)
                     new (cons 6 "BYLAYER")
                     ed (subst new old ed)
               )
            )
         )
         (entmod ed)          
      );progn
   )
)
