;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setvar "CMDECHO" 0)
(prompt "\nCLO : Cam duong cong clothoid")
(prompt "\n Nguyen Quoc Cuong - 06/1998")
(princ)

(defun  *error* (msg)
   (setvar "OSMODE" oslast)
   (princ msg)
   (princ) 
);defun

(defun deflt (str1 def)
   (strcat Str1 "<" (rtos def 2 3 ) ">: ")
);defun

(defun Xcal (S )
   (+ (- S ( / (expt S 5.0) 40.0 (expt C 2.0))) ( / (expt S 9.0) 3456.0 (expt C 4.0)))
);defun

(defun Ycal (S )  
   (+ (- ( / (expt S 3.0) 6.0 C ) ( / (expt S 7.0) 336 (expt C 3.0))) ( / (expt S 11.0) 42240.0 (expt C 5.0)))
);defun

(defun DtR (deg) ; converts degree to radian
   (/ (* deg pi) 180)
);defun

(defun RtD (rad) ; converts radian to degree
   (/ (* rad 180) pi)
);defun

(defun tg (rad) ; tangent of an angle in radian
   (/ (sin rad) (cos rad))
);defun

(defun arcsin (num) ; arcsin of number - return angle in radian
 (if (or (< num -1.0) (> num 1.0))
   (prompt "\nInput value to calculate arcsin out of range")
   (- (/ pi 2) (atan (sqrt (- 1 (expt num 2))) num) )
 );if
);defun

(defun c:CLO( / pt pt1 pt2 T1 T2 L1 L2 Lmin B tt2 K0 p al al2 phi1 phi2 ang1 ang2 dist1
                 pt11 pt31 ptmid angmid x y x01 y01 x02 y02 SS SC oslast)
   (setq oslast (getvar "OSMODE"))
   (command "ucs" "w")
   (if (not *L1) (setq *L1 100.0))
   (if (not *L2) (setq *L2 100.0))
   (if (not  *R) (setq *R  600.0))
   (if (not *SC) (setq *SC 5.0))
   (setvar "OSMODE" 33)
   (setq pt  (getpoint "\nDinh duong cong :_end,int of " ))
   (setvar "OSMODE" 512)
   (setq pt1  (getpoint "\nCanh tuyen 1 :_nearest of ")
      pt2  (getpoint "\nCanh tuyen 2 :_nearest of ")
      ang1 (angle  pt pt1)
      ang2 (angle  pt pt2)
      al   (abs (- pi (abs (- ang1 ang2))))
      R    (getreal (deflt "\nNhap R : " *R))
   )
  (if (not R ) (setq R   *R) (setq *R   R))
  (setq L1  (getreal (deflt (strcat "\nNhap L1 (L1<=" (rtos (* 2 R al) 2 2) ") :" ) *L1)))
   (if (not L1) (setq L1 *L1) (setq *L1 L1))
  (setq L2  (getreal (deflt (strcat "\nNhap L2 (L2<=" (rtos (- (* 2 R al) L1) 2 2) ") :" ) *L2)))
   (if (not L2) (setq L2 *L2) (setq *L2 L2))
(if (and (/= L1 0.0) (/= L2 0.0))
  (setq Lmin (min L1 L2))
  (progn 
	(if (= L1 0.0) (setq Lmin L2))
	(if (= L2 0.0) (setq Lmin L1))
  );progn
);if
(if (or (/= L1 0.0) (/= L2 0.0))
  (setq SC (getreal (deflt (strcat "\nNhap khoang cach le (S<=" (rtos Lmin 2 2) ") :" ) *SC)))
);if
  (if (not SC) (setq SC *SC) (setq *SC SC))   
 
   
   (setq phi1 (/ L1 R 2.0)
         phi2 (/ L2 R 2.0)
       al0 (- al phi1 phi2)
   )
 (if (/= 0 L1)
     (setq C (* R L1)
        x01  (Xcal L1)
        y01  (Ycal L1)
     )
     (setq x01 0.0
           y01 0.0
     )
 );if
 (if (/= 0 L2)
     (setq C (* R L2)
          x02  (Xcal L2)
          y02  (Ycal L2)
     )
     (setq x02 0.0
           y02 0.0
     )
 );if

(setq S1 (+ y01 (* R (cos phi1)))
      S2 (+ y02 (* R (cos phi2)))
      D1 (/ S2 (cos (- al phi1))) 
      D2 (- D1 R (/ y01 (cos phi1)))
      tt2 (- x02 (* R (sin phi2)))
      T2 (- (* S2 (tg (- al phi1))) (/ (* D2 (cos phi1)) (sin al)) (- 0 tt2))
      T1 (+ x01 (* y01 (tg phi1)) (/ (* D2 (cos (- al phi1))) (sin al)))
      K0 (* R al0)
      B  (- (sqrt (+ (expt (- T2 tt2) 2) (expt S2 2))) R)
   )
   
     
   (setq pt1 (polar pt ang1 T1)      
         pt2 (polar pt ang2 T2)      
         angmid (/ (+ ang2 ang1) 2)
   )

(setq dist1 (/ (distance pt1 pt2) 2)
      ptmid (polar pt1 (angle pt1 pt2) dist1) 
)

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;Draw spiral curve of the first spiral
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 (setvar "OSMODE" 0)

(command "UCS" "3" pt1 pt ptmid)   
(setq pt11 (list x01 y01))
(if (/= 0 L1)
(progn
 (setq SS SC
       C (* R L1)
 )
; (setvar "OSMODE" 0)
 (command "PLINE")      
 (command "0,0")
      (While (< SS L1)
       (progn
      (setq x (Xcal SS)
         y (Ycal SS)
         fpt (list x y)
         SS (+ SS SC)
      )
   (command fpt)      
    );progn  
   );while
   (command pt11)
   (command "")      
);progn
);if
   (setq pt11 (trans pt11 1 0))

   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;Draw spiral curve of the second spiral
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(command "UCS" "W")
(command "UCS" "3" pt2 pt ptmid)   
(setq ptmid (list tt2 S2)
      pt31 (list x02 y02)
)
(if (/= 0 L2)
(progn
 (setq SS SC
       C (* R L2)
 )
 (setvar "OSMODE" 0)
 (command "PLINE")      
 (command "0,0")
      (While (< SS L2)
       (progn
      (setq x (Xcal SS)
         y (Ycal SS)
         fpt (list x y)
         SS (+ SS SC)
      )
   (command fpt)      
    );progn  
   );while
   (command pt31)
   (command "")      
);progn
);if
(setq pt31  (trans pt31 1 0)
      ptmid (trans ptmid 1 0)
      ptmid (polar pt (angle pt ptmid) B)
)
(command "UCS" "W")

;;Draw the circular arc;;;;;

   (command "ARC"  pt11 ptmid pt31)

 (repeat 20
   (prompt "\n")
 )
  
   (prompt (strcat "\nGoc chuyen huong " (angtos al 1 5)))
   (prompt (strcat "\nL1 : " (rtos L1 2 4) "  L2 :" (rtos L2 2 4)))
   (prompt (strcat "\nR  : " (rtos R 2 4)))
   (prompt (strcat "\nT1 :" (rtos T1 2 4) "  T2 :" (rtos T2 2 4) ))
   (prompt (strcat "\nK0 : " (rtos K0 2 4) "  P  :" (rtos B 2 4)))
   (textpage)
   (setvar "OSMODE" oslast)
   (setvar "CMDECHO" 1)
   (graphscr)  
   (princ)
);defun CLO
(princ)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
