;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(vmon)
(setvar "CMDECHO" 0)
(prompt "\nCLOT  : Cam duong cong clothoid")
(prompt "\n  Nguyen Quoc Cuong - 06/1998")
(princ)

(defun  *error* (msg)
   (setvar "OSMODE" oslast)
   (princ msg)
   (princ) 
);defun

(defun deflt (str1 def)
   (strcat Str1 "<" (rtos def 2 3 ) ">: ")
);defun

(defun Xcal (S )
   (+ (- S ( / (expt S 5.0) 40.0 (expt C 2.0))) ( / (expt S 9.0) 3456.0 (expt C 4.0)))
);defun

(defun Ycal (S )  
   (+ (- ( / (expt S 3.0) 6.0 C ) ( / (expt S 7.0) 336 (expt C 3.0))) ( / (expt S 11.0) 42240.0 (expt C 5.0)))
);defun

(defun DtR (deg) ; converts degree to radian
   (/ (* deg pi) 180)
);defun

(defun RtD (rad) ; converts radian to degree
   (/ (* rad 180) pi)
);defun

(defun tg (rad) ; tangent of an angle in radian
   (/ (sin rad) (cos rad))
);defun


(defun c:CLOT( / pt pt1 pt2 T L B t1 K0 p al al2 phi ang1 ang2 dist1
                 pt11 pt31 ptmid angmid x y x0 y0 SS SC oslast)
   (setq oslast (getvar "OSMODE"))
   (if (not *L) (setq *L 100.0))
   (if (not  *R) (setq *R  600.0))
   (if (not *SC) (setq *SC 5.0))
   (setvar "OSMODE" 33)
   (setq pt  (getpoint "\nDinh duong cong :_end,int of " ))
   (setvar "OSMODE" 512)
   (setq pt1  (getpoint "\nCanh tuyen 1 :_nearest of ")
      pt2  (getpoint "\nCanh tuyen 2 :_nearest of ")
      ang1 (angle  pt pt1)
      ang2 (angle  pt pt2)
      al   (abs (- pi (abs (- ang1 ang2))))
      R    (getreal (deflt "\nNhap R : " *R))
   )
  (if (not R ) (setq R   *R) (setq *R   R))
  (setq L  (getreal (deflt (strcat "\nNhap L (L<=" (rtos (* R al) 2 2) ") :" ) *L)))
   (if (not L) (setq L *L) (setq *L L))

  (setq SC (getreal (deflt (strcat "\nNhap khoang cach le (S<=" (rtos L 2 2) ") :" ) *SC)))
  (if (not SC) (setq SC *SC) (setq *SC SC))   

 
   
   (setq phi (/ L R 2.0)
      ;      phi2 (/ L2 R 2.0)
      al0 (- al phi phi)
      al2 (/ al 2)
      C (* R L)
      x0  (Xcal L)
      y0  (Ycal L)
   )
   (setq p (- y0 (* R (- 1 (cos phi))))
      t1 (- x0 (* R (sin phi)))
      T  (+ (* (+ R p) (tg al2)) t1)
      K0 (* R al0)
      B  (+ (* (+ R p) (- (/ 1 (cos al2)) 1) ) p)
   )
   
     
   (setq pt1 (polar pt ang1 T)      
         pt2 (polar pt ang2 T)      
         angmid (/ (+ ang2 ang1) 2)
   )

(setq dist1 (/ (distance pt1 pt2) 2)
      ptmid (polar pt1 (angle pt1 pt2) dist1) 
)
(setq ptmid (polar pt (angle pt ptmid) B))

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;Draw spiral curve of the first spiral
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(command "UCS" "3" pt1 pt ptmid)   
(setq pt11 (list (Xcal L) (Ycal L)))
 (setq SS SC)
 (setvar "OSMODE" 0)
 (command "PLINE")      
 (command "0,0")
      (While (< SS L)
       (progn
      (setq x (Xcal SS)
         y (Ycal SS)
         fpt (list x y)
         SS (+ SS SC)
      )
   (command fpt)      
    );progn  
   );while
   (command pt11)
   (command "")      
   (setq pt11 (trans pt11 1 0))

   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;Draw spiral curve of the second spiral
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(command "UCS" "W")
(command "UCS" "3" pt2 pt ptmid)   
(setq pt31 (list (Xcal L) (Ycal L)))
(setq SS SC)
 (setvar "OSMODE" 0)
 (command "PLINE")      
 (command "0,0")
      (While (< SS L)
       (progn
      (setq x (Xcal SS)
         y (Ycal SS)
         fpt (list x y)
         SS (+ SS SC)
      )
   (command fpt)      
    );progn  
   );while
   (command pt31)
   (command "")      
   (setq pt31 (trans pt31 1 0))

(command "UCS" "W")

;;Draw the circular arc;;;;;

   (command "ARC"  pt11 ptmid pt31)

 (repeat 20
   (prompt "\n")
 )
  
   (prompt (strcat "\nGoc chuyen huong " (angtos al 1 5)))
   (prompt (strcat "\nL1 : " (rtos L 2 4) "  L2 :" (rtos L 2 4)))
   (prompt (strcat "\nR  : " (rtos R 2 4) "  T  :" (rtos T 2 4)))
   (prompt (strcat "\nK0 : " (rtos K0 2 4) "  P  :" (rtos B 2 4)))
   (textpage)
   (setvar "OSMODE" oslast)
   (setvar "CMDECHO" 1)
   (graphscr)  
   (princ)
);defun CLOT
(princ)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
