(prompt "\nLoading CAD Utilities Written by NTTLe-TEDI South, Ver 2.0 ")
;----------------------------------------------------------------------
(defun NS (x1 y1 x2 y2 x)
  (+ y1 (* (- x x1) (/ (float (- y1 y2)) (float (- x1 x2)))))
)
;----------------------------------------------------------------------
(defun UDIST (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getdist msg bpt)
      (getdist msg)
    )
  )
  (if inp inp def)
)	
;----------------------------------------------------------------------
(defun UKWORD (bit kwd msg def / inp)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getkword msg))
  (if inp inp def)
)
;----------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          inp (getstring spflag msg)
          inp (if (= inp "") def inp)
    )
    (progn
      (if (= " " (substr msg (strlen msg) 1))
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
        (setq msg (strcat "\n" msg ": "))
      )
      (if (= bit 1)
        (while (= "" (setq inp (getstring spflag msg)))
           (prompt "\nInvalid String.")
        )
        (setq inp (getstring spflag msg))
      )
    )
  )
  inp
)
;----------------------------------------------------------------------
(defun UINT (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (itoa def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getint msg))
  (if inp inp def)
)
;----------------------------------------------------------------------
(defun UREAL (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def 2) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getreal msg))
  (if inp inp def)
)	
;----------------------------------------------------------------------
(defun UPOINT (bit kwd msg def bpt / inp)
  (if def
    (setq pts (strcat 
                 (rtos (car def)) "," (rtos (cadr def))
                 (if
                   (and (caddr def) (= 0 (getvar "FLATLAND")))
                   (strcat "," (rtos (caddr def))) 
                   ""
                 )
              )
          msg (strcat "\n" msg "<" pts ">: ")
          bit (* 2 (fix (/ bit 2)))
    ) 
    (if (= " " (substr msg (strlen msg) 1))
       (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
       (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getpoint msg bpt)
      (getpoint msg)
    )
  )
  (if inp inp def)
) 
;----------------------------------------------------------------------
(defun UANGLE (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (angtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getangle msg bpt)
      (getangle msg)
    )
  )
  (if inp inp def)
)
;----------------------------------------------------------------------
(defun CMDECH (mode)
  (if (= mode 1)
    (setvar "CMDECHO" 0)
    (setvar "CMDECHO" 1) 
  )
  (graphscr)
  (princ)
)
;----------------------------------------------------------------------
(defun DXF (code elist)
  (cdr (assoc code elist))
)
;----------------------------------------------------------------------
(defun RAD (degree)
  (setq radian (/ (* degree 3.1416) 180))
  radian
)
;----------------------------------------------------------------------
(defun DEG (Rad)
  (setq degree (/ (* rad 180) 3.1416))
  degree
)
;----------------------------------------------------------------------
(defun ETOS (arg / file)
  (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
  (setq file (open "$" "w"))
  (princ arg file)
  (close file)
  (setq file (open "$" "r"))
  (setq arg (read-line file))
  (close file)
  (close (open "$" "w"))
  arg
)  
;----------------------------------------------------------------------
(defun fopen ( fname mode msg / fh )
  (setq fh (open fname mode))
  (while (= fh nil)
    (progn
       (Prompt (strcat "\nFile " msg " Not Found !"))
       (setq fname (USTR 1 (strcat "\nInput " msg " Again : ") nil T)
             fh (open fname mode)
       ) 
    )
  )
  fh
)
;----------------------------------------------------------------------
(defun round (number accuracy)
  (atof (rtos number 2 accuracy))
)
;----------------------------------------------------------------------
(prompt "\n DAH : Ve duong anh huong thanh")
(defun c:dah( / fn fh X Y SoPhanTu SoNut i NODES ELEMENTS line str V_scale
                node tungdo pt pt1 pt2 )
  (setq fn (USTR 1 "Nhap Ten File So Lieu" nil T)
        fh (fopen fn "r" fn)
        V_scale (UINT 4 "" " Ti Le Dung " 5)
  )
  (command "LAYER" "M" "1" "C" "1" "1" "")
  (command "STYLE" "22" "VN_VNI" "0.6" "" "" "" "" "")
  (setq X (read (strcat "(" (read-line fh) ")"))
        Y (read (strcat "(" (read-line fh) ")"))
        SoPhanTu (nth 1 (read (strcat "(" (read-line fh) ")")))
        SoNut (length X)
        i 0
  )
  (while (< i SoNut)
     (progn
        (setq NODES (append NODES (list (list (nth i X) (nth i Y))))
              i (+ 1 i)
        )
     )
  )
  (setq i 0)
  (while (< i SoPhanTu)
     (progn
        (setq line (read (strcat "(" (read-line fh) ")"))
              ELEMENTS (append ELEMENTS (list (list (nth 1 line) (nth 2 line)))) 
              i (+ 1 i)
        )
     )
  )
  (setq pt1 (nth 0 NODES))
  (setq str (read-line fh))

  (while (/= str nil)
    (if (= (type (nth 0 (read (strcat "(" str ")")))) 'SYM)
        (progn
           (command "UCS" "O" (list 0 -50))
           (command "LAYER" "S" "0" "")
           (setq i 0)
           (while (< i SoPhanTu) 
              (progn
                  (setq pt (nth (- (nth 0 (nth i ELEMENTS)) 1) NODES)
                        pt2 (nth (- (nth 1 (nth i ELEMENTS)) 1) NODES)
                        i (+ 1 i)
                  )
                  (command "LINE" pt pt2 "")
              )
           )  
           (command "LAYER" "S" "1" "")
           (command "TEXT" "J" "BR" "0,0" "0" str)
           (setq str (read-line fh))
        )
        (progn
           (setq line (read (strcat "(" str ")"))
                 node (nth 0 line)
                 tungdo (* (nth 1 line) V_scale)
                 pt (list (car (nth (- node 1) NODES)) (cadr (nth 0 NODES)))
                 pt2 (polar pt (- 0 (/ PI 2)) tungdo)
           )
           (if (< (nth 1 line) 0)
              (progn
                 (command "TEXT" "J" "BR" pt "90" (strcat " " (etos (nth 1 line)) " "))
                 (command "TEXT" "J" "BL" pt "0" (etos node))
              )
              (progn
                 (command "TEXT" "J" "BL" pt "90" (strcat " " (etos (nth 1 line)) " "))
                 (command "TEXT" "J" "TR" pt "0" (etos node))
              )
           )
           (command "LINE" PT1 PT2 PT "")
           (setq pt1 pt2
                 str (read-line fh)
           )
        )
    ) 
  )
  (close fh)
)
;----------------------------------------------------------------------
(PROMPT "\n BDNL : Ve bieu do noi luc thanh")
(defun c:BDNL( / fn fh X Y SoPhanTu SoNut i NODES ELEMENTS line str V_scale
                node1 tungdo1 node2 tungdo2 lin2 pt1 pt2 B ang)
  (setq fn (USTR 1 "Nhap Ten File So Lieu" nil T)
        fh (fopen fn "r" fn)
        V_scale (UREAL 4 "" " Ti Le Dung " 0.015)
  )
  (command "LAYER" "M" "1" "C" "1" "1" "")
  (command "STYLE" "2" "VN_VNI" "0.4" "" "" "" "" "")
  (setq X (read (strcat "(" (read-line fh) ")"))
        Y (read (strcat "(" (read-line fh) ")"))
        SoPhanTu (nth 1 (read (strcat "(" (read-line fh) ")")))
        SoNut (length X)
        i 0
  )
  (while (< i SoNut)
     (progn
        (setq NODES (append NODES (list (list (nth i X) (nth i Y))))
              i (+ 1 i)
        )
     )
  )
  (setq i 0)
  (while (< i SoPhanTu)
     (progn
        (setq line (read (strcat "(" (read-line fh) ")"))
              ELEMENTS (append ELEMENTS (list (list (nth 1 line) (nth 2 line)))) 
              i (+ 1 i)
        )
     )
  )
  (setq str (read-line fh))

  (while (/= str nil)
    (if (=  (type (nth 0 (read (strcat "(" str ")")))) 'SYM)
        (progn
           (command "UCS" "O" (list 0 -50))
           (command "LAYER" "S" "0" "")
           (setq i 0)
           (while (< i SoPhanTu) 
              (progn
                  (setq pt1 (nth (- (nth 0 (nth i ELEMENTS)) 1) NODES)
                        pt2 (nth (- (nth 1 (nth i ELEMENTS)) 1) NODES)
                        i (+ 1 i)
                  )
                  (command "LINE" pt1 pt2 "")
              )
           )  
           (command "LAYER" "S" "1" "")
           (command "TEXT" "J" "BR" "0,0" "0" str)
           (setq str (read-line fh))
        )
        (progn
           (setq line (read (strcat "(" str ")"))
                 node1 (nth (- (nth 1 line) 1) NODES)
                 tungdo1 (* (nth 2 line) V_scale)
                 node2 (nth (- (nth 3 line) 1) NODES)
                 tungdo2 (* (nth 4 line) V_scale)
                 ang (angle node1 node2)
                 B (DEG (+ ang (/ pi 2)))
           )
           (setq pt1 (polar node1 (- ang (/ PI 2)) tungdo1))
           (setq pt2 (polar node2 (- ang (/ PI 2)) tungdo2))
           (command "TEXT" "J" "TL" NODE1 B (strcat " " (etos  (/ TUNGDO1 V_scale)) " "))
           (command "TEXT" "J" "BR" NODE2 B (strcat " " (etos (/ TUNGDO2 V_scale)) " "))
           (command "LINE" node1 PT1 PT2 node2"")
           (setq str (read-line fh))
        );progn
    );if
  );while
  (close fh)
)
;----------------------------------------------------------------------
(prompt "\n BDB : Ve bieu do bao")
(defun c:BDB( / fn fh X Y SoPhanTu SoNut i NODES ELEMENTS line str V_scale
                node min max node NODE1line pt1 pt2 pt_max pt_min )
  (setq fn (USTR 1 "Nhap Ten File So Lieu" nil T)
        fh (fopen fn "r" fn)
        V_scale (UREAL 4 "" " Ti Le Dung " 0.005)
  )
  (command "LAYER" "M" "1" "C" "1" "1" "")
  (command "STYLE" "22" "VN_VNI" "0.4" "" "" "" "" "")
  (setq X (read (strcat "(" (read-line fh) ")"))
        Y (read (strcat "(" (read-line fh) ")"))
        SoPhanTu (nth 1 (read (strcat "(" (read-line fh) ")")))
        SoNut (length X)
        i 0
  )
  (while (< i SoNut)
     (progn
        (setq NODES (append NODES (list (list (nth i X) (nth i Y))))
              i (+ 1 i)
        )
     )
  )
  (setq i 0)
  (while (< i SoPhanTu)
     (progn
        (setq line (read (strcat "(" (read-line fh) ")"))
              ELEMENTS (append ELEMENTS (list (list (nth 1 line) (nth 2 line)))) 
              i (+ 1 i)
        )
     )
  )

  (setq str (read-line fh))

  (while (/= str nil)
    (if (=  (type (nth 0 (read (strcat "(" str ")")))) 'SYM)
        (progn
           (command "UCS" "O" (list 0 -50))
           (command "LAYER" "S" "0" "")
           (setq i 0)
           (while (< i SoPhanTu) 
              (progn
                  (setq pt1 (nth (- (nth 0 (nth i ELEMENTS)) 1) NODES)
                        pt2 (nth (- (nth 1 (nth i ELEMENTS)) 1) NODES)
                        i (+ 1 i)
                  )
                  (command "LINE" pt1 pt2 "")
              )
           )  
           (command "LAYER" "S" "1" "")
           (command "TEXT" "J" "BR" "0,0" "0" str)
           (setq pt_max (nth 0 NODES)
                 pt_min ptmax
                 node1 (list (- (car pt_max) 10) (cadr pt_max))
           )
           (setq str (read-line fh))
        )
        (progn
           (setq line (read (strcat "(" str ")"))
                 node (nth (- (nth 0 line) 1) NODES)
                 max (* (nth 1 line) V_scale)
                 min (* (nth 2 line) V_scale)
                 ang (angle node1 node)
                 B (DEG (+ ang (/ pi 2)))
           )
           (setq pt1 (polar node (- ang (/ PI 2)) max))
           (setq pt2 (polar node (- ang (/ PI 2)) min))
           (command "TEXT" "J" "BR" PT1 B (strcat " " (etos  (/ MAX V_scale)) " "))
           (command "TEXT" "J" "BL" PT2 B (strcat " " (etos (/ MIN V_scale)) " "))
           (command "LINE" node PT1 pt_max "" )
           (command "LINE" node PT2 pt_min "" )
           (setq pt_max PT1
                 pt_min PT2
                 node1 node
           )
           (setq str (read-line fh))
        );progn
    );if
  );while
  (close fh)
)
;----------------------------------------------------------------------
(prompt "\n X8 : Xep xe HK80 len duong anh huong theo vi tri cho truoc")
(defun c:X8 (/ x y)
  (setq OS (getvar "OSMODE"))  
  (setvar "OSMODE" 0)
  (setq x (getreal "\nNhap gia tri X= "))
  (while (/= x nil)
    (progn
       (setq y (cadr (getpoint "\nPick gia tri y")))
       (command "INSERT" "hk80" (list x y) "1" "1" "0")
       (setq x (getreal "\n\nNhap gia tri X= "))
    );progn
  );while
  (setvar "OSMODE" OS)
);defun
;----------------------------------------------------------------------
(prompt "\n X3 : Xep xe H30 len duong anh huong theo vi tri cho truoc")
(defun c:X3 (/ x y xd xc sochiec i OS)
  (setq OS (getvar "OSMODE"))  
  (setvar "OSMODE" 0)
  (setq xd (getreal "\nNhap gia tri Xd= "))
  (setq xc (getreal "\nNhap gia tri Xc= "))
  (setq dir (getint "\nNhap chieu di/ve <1/0>: "))
  (setq y (cadr (getpoint "\nPick gia tri y")))
  (setq sochiec (+ (round (/ (- xc xd 7.6) 17.6) 0) 1))
  (setq i 0)
  (if (= dir 1)
    (progn
       (while (< i sochiec)
          (setq x (+ xd (* 17.6 i)))  
          (command "INSERT" "h30d" (list x y) "1" "1" "0")
          (setq i (+ i 1)) 
       );while
    );progn
    (progn
       (while (< i sochiec)
          (setq x (+ xd (* 17.6 i)))  
          (command "INSERT" "h30v" (list x y) "1" "1" "0")
          (setq i (+ i 1)) 
       );while
    );progn
  );if
  (setvar "OSMODE" OS)
);defun
;----------------------------------------------------------------------