// Next available MSG number is    24 
// MODULE_ID BMAKE_DCL_
//----------------------------------------------------------------------------
//
//     bmake.dcl
//
//     Copyright (C) 1991 - 1997 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.
//----------------------------------------------------------------------------
//
//  Dialogue interface to BLOCK command.  Used with BMAKE.LSP
//
//----------------------------------------------------------------------------


bmake : dialog {
    label = "Block Definition";
    : edit_box {
        label = "&Block name:";
        key = "bname";   
        edit_limit = 2048;
    }
    spacer;
    : row {
        : boxed_column { 
            label = "Base Point";
            : button {
                label = "Select &Point <";
                key = "pick_pt";                 
            }
            : edit_box {
                label = "&X:";
                key = "x_pt";
                edit_width = 10;
            }
            : edit_box {
                label = "&Y:";
                key = "y_pt";
                edit_width = 10;
            }
            : edit_box {
                label = "&Z:";
                key = "z_pt";
                edit_width = 10;
            }
        }
        : column {
            spacer_1;
            : button {
                label = "&Select Objects <";
                key = "sel_objs";                 
            }
            : concatenation {
                : text_part {
                    label = "Number found: ";
                }
                : text_part {
                    key = "how_many";
                    width = 5;
                }
             }
             spacer;
             : button {
                 label = "&List Block Names...";
                 key = "list_blocks";
             }
             : toggle {
                 label = "&Retain Objects";
                 key = "retain";
             }
         }
    }
   spacer; 
   spacer;
   ok_cancel_help_errtile;
}

bmake_bname_exists : dialog {
    label = "Warning";
    : paragraph {
        : text_part {
            label = "A Block with this name already exists in the drawing.";
        }
        : text_part {
            label = "Do you want to redefine it?";
        }
    }
    spacer_1;
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = "&Redefine";
            key = "yes";
            width = 8;
        }
        : spacer {
            width = 2;
        }
        : default_button {
            label = "Cancel";
            key = "no";
            width = 8;
        }
    }
}

bmake_list_blocks : dialog {
    label = "Block Names In This Drawing";
    : edit_box {
        label = "&Pattern:";
        key = "pattern";
    }
    : list_box {                                   
        key = "bl_match";
        width = 32;
    }
    spacer;
    ok_only;
}


