// Next available MSG number is    26 
// MODULE_ID DDATTEXT_DCL_
/* Next available MSG number is  26 */
//
//     ddattext.dcl
//
//     Copyright 1992, 1994, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.
//---------------------------------------------------------------------
//
// Dialogue definition file for DDATTEXT.LSP - Attribute extraction
//


//dcl_settings : default_dcl_settings { audit_level = 3; }


ddattext : dialog {
    label = "Attribute Extraction";
    : boxed_radio_column {
        label = "File Format";
        : radio_button {
            label = "Comma Delimited File (CDF)";
            key = "cdf";
            mnemonic = "C";
           }
           : radio_button {
            label = "Space Delimited File (SDF)";
            key = "sdf";
            mnemonic = "S";
        }
           : radio_button {
            label = "Drawing Interchange File (DXF)";
            key = "dxf";
            mnemonic = "D";
        }
    }
    : row {
        : button {
            label = "Select Objects <";
            mnemonic = "O";
            key = "selobjs";
            fixed_width = true;
        }
        : concatenation {
            : text_part {
                label = "Number found: ";
            }
            : text_part {
                key = "how_many";
                width = 5;
            }
        }
    }
    : row {
        : button {
            label = "Template File... ";
            key = "select_temp_file";
            mnemonic = "T";
        }
        : edit_box {
            edit_width = 20;
            key = "temp_file";
            fixed_width = true;
        	edit_limit = 259;
        }
    }
    : row {
        : button {
            label = "Output File... ";
            key = "select_out_file";
            mnemonic = "F";
        }
        : edit_box {
            edit_width = 20;
            key = "out_file";
            fixed_width = true;
        	edit_limit = 259;
        }
    }
    ok_cancel_help_errtile;
}

out_exists : dialog {
    label = "Warning";
    : paragraph {
        : text_part {
            label = "The output file already exists.";
        }
        : text_part {
            label = "Do you want to replace it?";
        }
    }
    spacer_1;
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = "Yes";
            mnemonic = "R";
            key = "yes";
            width = 8;
        }
        : spacer {
            width = 2;
        }
        : default_button {
            label = "No";
            mnemonic = "C";
            key = "no";
            width = 8;
        }
    }
}

out_temp : dialog {
    label = "Warning";
    : paragraph {
        : text_part {
            label = "The template file and output file have the same name.";
        }
        : text_part {
            label = "Please change the output file name.";
        }
    }
    spacer_1;
    : ok_button {
        is_cancel = true;
    }
}


