(setvar "cmdecho" 0)
(defun DXF (code elist)
  (cdr (assoc code elist))
)
;--------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          inp (getstring spflag msg)
          inp (if (= inp "") def inp)
    )
    (progn
      (if (= " " (substr msg (strlen msg) 1))
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
        (setq msg (strcat "\n" msg ": "))
      )
      (if (= bit 1)
        (while (= "" (setq inp (getstring spflag msg)))
           (prompt "\nInvalid String.")
        )
        (setq inp (getstring spflag msg))
      )
    )
  )
  inp
)
;-------------------------------------------------------------
(defun ETOS (arg / file)
  (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
  (setq file (open "$" "w"))
  (princ arg file)
  (close file)
  (setq file (open "$" "r"))
  (setq arg (read-line file))
  (close file)
  (close (open "$" "w"))
  arg
)
;---------------------------------------------------------------
(defun UDIST (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getdist msg bpt)
      (getdist msg)
    )
  )
  (if inp inp def)
)	
(setq wb (strcat (chr 87) (chr 114) (chr 105) (chr 116) (chr 116) (chr 101)
(chr 110) " " (chr 66) (chr 121) " " (chr 78) (chr 84) (chr 84) (chr 76) (chr 101)))

;-------------------------------------------------------------------
(defun OSMODE ( mode )
  ( if (= mode 1) 
       (setvar "OSMODE" #OSMODE) 
       (progn
          (setq #OSMODE (getvar "OSMODE"))
          (setvar "OSMODE" 0)
       )
  )
)

;---------------------------------------------------------------------
(defun CMDECH (mode)
  (if (= mode 1)
    (setvar "CMDECHO" 0)
    (setvar "CMDECHO" 1) 
  )
  (graphscr)
  (princ)
)

;---------------------------------------------------------------------
(defun c:bTK(/ i j line k h w n p p1 p2 p3 f1 dz last)
   (initget (+ 1 2 4))
   (setq name (getstring "\n Ten file "))
   (setq h (getreal "\n Chieu cao 1 dong(8): "))   
   (if (= h nil) (setq h 8))
   (setq w (getreal "\n Chieu rong 1 cot(20): "))
   (if (= w nil) (setq w 20))
   (setq rr (getint "\n do chinh xac (2): "))
   (if (= rr nil) (setq rr 2))  
   (setq p (getpoint "\nNoi dat bang: ")
         p1 p
         p2 p
   )
   (setq last (getvar "osmode"))
   (command "osnap" "none")
   (setq DZ (getvar "DIMZIN"))
   (setvar "DIMZIN" 0)
   (command "layer" "s" "0" "")
   (setq f (open name "r"))
   (setq n 0)
   (while (setq line (read-line f))
     (setq line (read (strcat "(" line ")"))
             p3 (list (+ (/ w 2) (car p)) (- (cadr p) (* h n) (/ h 2))))
     (setq k 0)
     (repeat (length line)
       (if (/= (etos (nth k line)) "O")
          (progn
            (if (= (type (nth k line)) 'sym)
              (command "text" "J" "MC" p3 "0" (ETOS (nth k line)))
              (command "text" "J" "MC" p3 "0" (rtos (float (nth k line)) 2 rr))
            ) 
              (setq p3 (list (+ w (car p3)) (cadr p3)))
          )
       )
       (if (= (etos (nth k line)) "O")
          (progn
            (setq p3 (list (+ w (car p3)) (cadr p3)))
          )
       )
       (setq k (+ 1 k))
     )
     (setq n (+ 1 n))
   )
  (close f)
  (command "layer" "m" "4" "c" "4" "" "")
  (setq i 0)
  (repeat (+ 1 n)
      (command "line" p1 (polar p1 0 (* w k)) "")
      (setq i (+ 1 i)
            p1 (list (car p) (- (cadr p) (* h i)
                             )
               )
      )
   )
   (setq j 0)
   (repeat (+ 1 k)
      (command "line" p2 (polar p2 (* (/ pi 2) 3) (* h n)) "")
      (setq j (+ 1 j)
            p2 (list (+ (car p) (* w j)) (cadr p))
      )
   )
(setvar "osmode" last)
(setvar "DIMZIN" DZ)
)

;---------------------------------------------------------------------
(defun c:CUT( / pt1 pt2 pt3 pt4 pt5 pt6 x1 x2 y1 y2 dx dy xx1 yy1 
                xx2 yy2 xx3 yy3 xx4 yy4 a b)
  (prompt "\nExpansion symbol. ") 
  (prompt wb)
  (OSMODE 0)
  (CMDECH 1)
  (if #dist #dist (setq #dist 0))
  (setq pt1 (getpoint "\nFirst point : ")
  	pt2 (getpoint "\nSecond point : " pt1)
  	#dist (abs (UDIST 0 "" "How big ?" #dist nil))
  	x1 (car pt1)
        y1 (cadr pt1)
	x2 (car pt2)
	y2 (cadr pt2)
        a (angle pt1 pt2)
        b (- (/ PI 2) a)
	dx (* (/ #dist 3) (cos a))
	dy (if (= (cos a) 0) (/ #dist 3) (* dx (/ (sin a) (cos a))))
        xx1 (- (/ (+ x2 x1) 2) (/ dx 2))
	yy1 (- (/ (+ y2 y1) 2) (/ dy 2))
	xx2 (+ (/ (+ x2 x1) 2) (/ dx 2))
	yy2 (+ (/ (+ y2 y1) 2) (/ dy 2))
	dx  (* (/ #dist 2) (cos b))
	dy  (* (/ #dist 2) (sin b))
	xx3 (- (/ (+ x2 x1) 2) dx)
	yy3 (+ (/ (+ y2 y1) 2) dy)
	xx4 (+ (/ (+ x2 x1) 2) dx)
	yy4 (- (/ (+ y2 y1) 2) dy)
	pt3 (list xx1 yy1)
	pt4 (list xx3 yy3)
	pt5 (list xx4 yy4)
	pt6 (list xx2 yy2)
  )
(command "PLINE" pt1 pt3 pt4 pt5 pt6 pt2 "")
(OSMODE 1)
)

;-------------------------------------------------------------------
(Defun c:ad()
  (setq pt (getpoint "\n Select internal point"))
  (command "-boundary" pt "")
  (command "area" "o" "l")
  (command "erase" "l" "") 
  (setq a (getvar "area")) 
  (setq a (/ a 10000))
  (princ)  
  (print a) 
)

;--------------------------------------------------------------------
(defun refine1a ( / nsset temp ed ac)
   (setq DZ (getvar "DIMZIN"))
   (setvar "DIMZIN" 0)

  (setq ssl   (sslength sset); 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT")
        (progn
          (if (/= (TYPE (READ (DXF 1 ed))) 'SYM) 
            (ssadd temp nsset)
          )
        )
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "text entities found. ")
  (princ "\n play " )
  (setq tl (getint "\n Input number of bars : "))
  (setq ac (getint "\n Input accuracy: "))

  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq No (atof (DXF 1 ed)))
      (setq No (/ (* No tl) 1000))
      (setq new (cons 1 (rtos No 2 ac)))
      (setq ed (subst new old ed))
      (entmod ed)  
    )
  )
(setvar "DIMZIN" DZ)
)

;------------------------------------------------------------------
(defun refine2a ( / nsset temp ed ac)
   (setq DZ (getvar "DIMZIN"))
   (setvar "DIMZIN" 0)

  (setq ssl   (sslength sset); 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT")
        (progn
          (if (/= (TYPE (READ (DXF 1 ed))) 'SYM) 
            (ssadd temp nsset)
          )
        )
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "text entities found. ")
  (princ "\n play " )
  (setq d (getreal "\n Input diameter: "))
  (setq d (* (/ d 1000) (/ d 1000))) 
  (setq ac (getint "\n Input accuracy: ")) 

  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq No (atof (DXF 1 ed)))    
      (setq No (/ (* No pi d 7850) 4))
      (setq new (cons 1 (rtos No 2 ac)))
      (setq ed (subst new old ed))
      (entmod ed)  
    )
  )
(setvar "DIMZIN" DZ)
)

;------------------------------------------------------------------
(defun c:TT()
(setq sset (ssget))
(refine1a)
)

;------------------------------------------------------------------
(defun c:klt()
(setq sset (ssget))
(refine2a)
)

;------------------------------------------------------------------
(prompt " \n doc : To insert a DOC block")
(defun c:DOC ( / DZ pt1 pt2 pt x1 x2 y1 y2 y i ang )
     (if (= scale nil)
          (progn
               (setq scale (getreal "\nInput current scale: "))
          )
     )
     (setq DZ (getvar "DIMZIN"))
     (setvar "DIMZIN" 0)
     (setq pt1 (getpoint "\nPick 1st point"))
     (setq pt2 (getpoint "\nPick 2nd point" pt1))
     (setq x1 (car pt1)
          y1 (cadr pt1)
          x2 (car pt2)
          y2 (cadr pt2)
          x (/ (+ x1 x2) 2)
          y (/ (+ y1 y2) 2)
          y (+ y (* 1.5 scale))
          pt (list x y)
     )
     (if (> x2 x1)
          (progn
               (setq i (* (/ (- y1 y2) (- x2 x1)) 100)
                    i (strcat (rtos i 2 2) "%")
                    i (ustr 0 "Input i%: " i T)
                    ang (/ (* (angle pt1 pt2) 180) pi)
               )
               (command "INSERT" "ddoc" pt scale scale ang i)
          )
          (progn
               (setq i (* (/ (- y1 y2) (- x1 x2)) 100)
                    i (strcat (rtos i 2 2) "%")
                    i (ustr 0 "Input i%: " i T)
                    ang (/ (* (angle pt2 pt1) 180) pi)
               )
               (command "INSERT" "ddoc1" pt scale scale ang i)
          )
     )
     (setvar "DIMZIN" DZ)
)
(princ)
;------------------------------------------------------------------------------------------
(defun c:cd ( / DZ pt y ptside ang OT)
     (if (= scale nil)  (setq scale (getreal "\nInput current scale: ")))
     (if (= #acc nil) (setq #acc (getint "\nInput accuracy: ")))
     (setq DZ (getvar "DIMZIN"))
     (setvar "DIMZIN" 0)
     (setq OT (getvar "ORTHOMODE"))
     (setvar "ORTHOMODE" 0)
     (setq pt (getpoint "\nPick Insertion Point")
     		 ptside (getpoint "\nPick Side Point" pt)
		 ang (angle pt ptside)
     )

     (setq y (/ (cadr pt) 100.0))
     (cond
          ((> y 0) (setq y (strcat "+" (rtos y 2 #acc))))
          ((< y 0) (setq y (rtos y 2 #acc)))
          ((= y 0) (setq y "%%p0.00"))
     )
     (setq y (ustr 0 "Input elevation: " y T))
     ( if	 (AND (>= ang 0) (< ang 1.5708)) (command "INSERT" "CD" pt scale scale "0" y))
     ( if	 (AND (>= ang 1.5708) (< ang 3.1416)) (command "INSERT" "CD3" pt scale scale "0" y))
     ( if	 (AND (>= ang 3.1416) (< ang 4.7124)) (command "INSERT" "CD2" pt scale scale "0" y))
     ( if	 (AND (>= ang 4.7124) (< ang 6.2832)) (command "INSERT" "CD1" pt scale scale "0" y))
     (setvar "DIMZIN" DZ)
     (setvar "ORTHOMODE" OT)

)
;--------------------------------------------------------------------------------------------
(prompt "\n	MC : To insert MC block")
(defun c:MC (  / pt1 pt2 ptside ang1 ang2 )
;	(if (= scale nil) (c:tl))
        (if (= scale nil)
            (setq SCALE (getreal "Input current scale : ")))

	(if (= #MC nil) (setq #MC "A"))
	(setq pt1 (getpoint "\nPick the first point :")
		 pt2 (getpoint "\nPick the second point :" pt1)
;		 ptside (getpoint "\nPick Side point :" pt2)
	         	 #MC (ustr 0 "Name: " #MC T)
		 ang1 (/ (* (angle pt1 pt2) 180) PI)
	)
	(if (> ang1 180) (setq ang1 (- ang1 180)))
	(if (> ang1 0) 
		(setq  ang2 (- ang1 90))
		(setq  ang2 (+ ang1 90))
	)
	(command "INSERT" "MC1" pt1 scale scale ang2 #MC)
	(command "INSERT" "MC1" pt2 scale scale ang2 #MC)
	(setq #MC (chr (+ (ascii #MC) 1)))
);defun
;--------------------------------------------------------------------------------------------

(prompt " \n MC : To insert a MC block")
(prompt " \n CD : To insert a CD block")
(prompt " \n doc : To insert a DDOC block") 
(prompt "\n CUT() : Draw expansion symbol")
(prompt "\n BTK() : Tao bang thong ke ")
(prompt "\n AD()  : Tinh dien tich (don vi met)")
(prompt "\n TT()  : Tinh tong chieu dai thep (don vi met)")
(prompt "\n KLT() : Tinh khoi luong thep (don vi kg)")
(prompt "\n Dhf : Tinh dac trung hinh hoc cua cac hnh da giac (khong tnh duoc cac hinh tao thanh tu mot phan la cac cung tron)")

(prompt "\n cno() : Tinh (*,/,+,-) ")
(princ)
