// Next available MSG number is 
// MODULE_ID ASEUPD_DCL_
//----------------------------------------------------------------------------
//
//     ASEUPD.DCL          AutoCAD SQL Environment Utility dialog file
//
//     Copyright (C) 1991-1997 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//----------------------------------------------------------------------------

dcl_settings : default_dcl_settings { audit_level = 0; }

linkpath_text : row {
    : text {
        label         = "Table Path:";
        alignment     = left ;
        fixed_width   = true ;
        width         = 0;
    }
    : text {
        key   = "ID_TEXT_LINKPATH";
        alignment     = right ;
        width         = 40 ;
        fixed_width   = true ;
    }
}
msg_text  : text {
   	key   = "ID_TEXT_MSG";
	label = "";
}
exit_button : retirement_button {
    label           = " OK ";
    key             = "accept";
    is_default      = true;
    is_cancel       = true;
}
update_button: retirement_button {
    key 	= "ID_BUTTON_UPDATE";
    label	= "&Update";
}

aseupd_dlg : dialog {   
label = "Link Path Update";
    : boxed_column {
        label = "Link Path";
        : popup_list {
            key            = "ID_POPUP_LPN";       
            label          = "&Link Path Name:";
            alignment = left;
		    edit_width = 38;
        }
        linkpath_text;
    }
    : boxed_column {
        label = "New Table Path";
        : popup_list {
            key            = "ID_POPUP_ENV";       
            label          = "&Environment:";
		    edit_width = 38;
        }
        : popup_list {
            key            = "ID_POPUP_CAT";       
            label          = "&Catalog:";
		    edit_width = 38;
        }
        : popup_list {
            key            = "ID_POPUP_SCH";       
            label          = "&Schema:";
		    edit_width = 38;
        }
        : popup_list {
            key            = "ID_POPUP_TAB";       
            label          = "&Table:";
		    edit_width = 38;
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        update_button;
        : spacer { width = 2; }
        exit_button;
    }
	msg_text ;
}
