// Next available MSG number is   120
// MODULE_ID DDIM_DCL_
/* Next available MSG number is 185 */
//
//     DDIM.DCL      Version 1.0
//
//     Copyright 1991, 1992, 1993, 1994, 1995, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.
//
//

ddimx_row :row{
    children_alignment = bottom;
}

//
// Dimension line color
//
ddimx_colord :ddimx_row{

    :button{
        label = "&Color...";
        key = "clrdl";
    }
    :spacer{ width = 7; }
    :swatch{
        key = "clrd";
    }
    :edit_box{
        key = "clrdt";
        edit_width = 12;
    }
}

//
// Extension line color
//
ddimx_colore :ddimx_row{

    :button{
        label = "Colo&r...";
        key = "clrel";
    }
    :spacer{ width = 7; }
    :swatch{
            key = "clre";
    }
    :edit_box{
        key = "clret";
        edit_width = 12;
    }
}
//
// Dimension text color
//
ddimx_colort :ddimx_row{

    :button{
        label = "&Color...";
        key = "clrtl";
        fixed_width = true;
        width = 10;
    }
    :spacer{ width = 7; }
    :swatch{
        key = "clrt";
    }
    :edit_box{
        key = "clrtt";
        edit_width = 12;
    }
}

ddimx_alert :dialog{
    label = "ALERT";
    :text{
        label = "Save changes to current style?";
        key = "dalert_sty";
        alignment = centered;
    }
    :spacer{ height = 0.5; }
    :row{
        fixed_width = true;
        alignment = centered;
        :button{
            label = "&Yes";
            key = "dalert_save";
            width = 8;
            fixed_width = true;
        }
        :spacer{ width = 1; }
        :button{
            label = "&No";
            key = "dalert_discard";
            width = 8;
            fixed_width = true;
        }
        :spacer{ width = 1; }
        :button{
            label = "&Cancel";
            key = "dalert_cancel";
            is_cancel = true;
            width = 8;
            fixed_width = true;
        }
    }
    :spacer{ height = 0.5; }
}

ddimx_alert_fam :dialog{
    label = "ALERT";

  //This alert message is:
  //  
  //      Running overrides can only be set for 
  //            Parent dimension styles.
  //
    :text{
        label = "Running overrides can only be set for";
        alignment = centered;
    }
    :text{
        label = "Parent dimension styles.";
        alignment = centered;
    }
    :spacer{ height = 0.5; }
    ok_only;
    :spacer{ height = 0.5; }
}

// ===============================================================
//
//  Dimension Style Main Dialog -  calls Geometry, Text Location
//                                  and Annotation subdialogs
//          
// ===============================================================

ddim :dialog{
    label = "Dimension Styles";
    :boxed_column{
        label = "Dimension Style";
        fixed_width = true;
        :row{
            :text_part{
                label = "&Current:";
                width = 9;
                fixed_width = true;
            }
            :popup_list{            // lists for current working dimstyles
                key = "style";
                list = "";
                edit_width = 31;
            }
        }
        :row{
            :text_part{
                label = "&Name:";     //  style name
                width = 9;
                fixed_width = true;
            }
            :edit_box{                        // for user to enter/specify 
                key = "editstyle";
                edit_width = 31;
                edit_limit = 217;
            }
        }
        :row{
            fixed_width = true;
            alignment = centered; 
            :button{                      // save/create edited dimstyle         
                label = "&Save";
                key = "save";
                width = 10;
            }
            :spacer{ width = 0.5; }
            :button{                      // rename selected dimstyle name
                label = "&Rename";
                key = "rename";
                width = 10;
            }
            :spacer{ width = 0.2; }
        }
    }
    :row{
        :boxed_row{

        // Since DCL doesn't support m x n matrix radio buttons,
        // we have to manually track the choice from multiple clusters
        // as if they were a sinble cluster.
        // When a button from the other cluster was selected, turn off 
        // the current button by sweeping the cluster first, then let
        // the chosen button on. This operation is done in apps.

            label = "Family";
            :radio_column{
                key = "family1";
                        :radio_button{
                            label = "&Parent";
                            key = "parent";
                        }
                        :radio_button{
                            label = "&Linear";
                            key = "linear";
                        }
                        :radio_button{
                            label = "Ra&dial";
                            key = "radius";
                        }
                        :radio_button{
                            label = "Ang&ular";
                            key = "angle";
                        }
            }
            :radio_column{
                key = "family2";
                // Somehow in this layout of clusters, they are
                // slightly off balanced. In other words, the buttons
                // in each clusters are not displayed horizontally. 
                // To correct the bias, we used a spacer of 1.5.

                        : spacer { height = 1.5; }
                        :radio_button{
                            label = "Dia&meter";
                            key = "diameter";
                        }
                        :radio_button{
                            label = "&Ordinate";
                            key = "ordinate";
                        }
                        :radio_button{
                            label = "L&eader";
                            key = "leader";
                        }
            }
        }
        :column{
            alignment = top;
            :spacer{ height = 0.7; }
            :button{                  // calls subdialog
                label = "&Geometry...";  
                key = "geometry";
            }
            :button{                  // calls subdialog
                label = "&Format...";
                key = "txtloc";
            }
            :button{                  // calls subdialog
                label = "&Annotation...";
                key = "annotation";
            }
        }
    }
    spacer;
    ok_cancel_help_errtile;
}

//
//  Dimension Geometry Subdialog
//

ddimx_geometry :dialog{
    label = "Geometry";
    :row{
        fixed_height = true;
        :column{
            :boxed_column{
            //
            // This is boxed column for Dimension Line.
            //
                label = "Dimension Line";
                key = "g_diml";
                :row{
                    :text{
                        label = "Suppress: ";
                    }
                    :column{
                        :spacer{ height = 0.2; }
                        :toggle{
                            label = "&1st";
                            key = "sd1";
                        }
                    }
                    :column{
                        :spacer{ height = 0.2; } 
                        :toggle{
                            label = "&2nd";
                            key = "sd2";
                        }
                    }
                }
                :edit12_box{
                    label = "&Extension: ";
                    key = "dle";
                }
                :edit12_box{
                    label = "Sp&acing: ";
                    key = "dli";
                }
                ddimx_colord;
            }
            :boxed_column{
            //
            // This is boxed column for Extension Line.
            //
                label = "Extension Line";
                key = "extline";
                :row{
                    key = "g_extl";
                    :text{
                        label = "Suppress: ";
                    }
                    :column{
                        :spacer{ height = 0.3; }
                        :toggle{
                            label = "1&st";
                            key = "se1";
                        }
                    }
                    :column{
                        :spacer{ height = 0.3; }
                        :toggle{
                            label = "2&nd";
                            key = "se2";
                        }
                    }
                }
                :edit12_box{
                    label = "E&xtension: ";
                    key = "exe";
                }
                :edit12_box{
                    label = "Origin O&ffset: ";
                    key = "exo";
                }
                ddimx_colore;
            }
        }
        :column{
            :boxed_column{
       
            // This is boxed column for Arrwos.
            // In this popup lists, 'User Arrow' will let you open another
            // subdialog called 'ddimx_userarr'. 

                label = "Arrowheads";
                key = "g_arrs";
                :row{
                    fixed_width = true;
                    alignment = right;
                    :image_button{
                        color                   = 0;
                        width                   = 8.7;
                        aspect_ratio            = 0.36;
                        fixed_height            = true;
                        fixed_width             = true;
                        alignment = right;
                        key = "arr_icon1";
                    }
                    :image_button{
                        color                   = 0;
                        width                   = 8.7;
                        aspect_ratio            = 0.36;
                        fixed_height            = true;
                        fixed_width             = true;
                        alignment = right;
                        key = "arr_icon2";
                    }
                }
                :popup_list{
                    label = "1s&t: ";
                    key = "blk1";
                    list = "None \nClosed \nDot \nClosed Filled \nClosed Blank \nOblique \nArchitectural Tick \nOpen \nOrigin Indication \nRight-Angle \nOpen 30 \nDot Blanked \nDot Small \nBox Filled \nBox \nDatum Triangle Filled \nDatum Triangle \nIntegral \nUser Arrow...";
                    edit_width = 20;
                }
                :popup_list{
                    label = "2n&d:";
                    key = "blk2";
                    list = "None \nClosed \nDot \nClosed Filled \nClosed Blank \nOblique \nArchitectural Tick \nOpen \nOrigin Indication \nRight-Angle \nOpen 30 \nDot Blanked \nDot Small \nBox Filled \nBox \nDatum Triangle Filled \nDatum Triangle \nIntegral \nUser Arrow...";
                    edit_width = 20;
                }
                :edit12_box{
                    label = "S&ize: ";
                    key = "asz";
                }
            }
            :boxed_column{
                key = "cenmarks";

            // This is boxed column for center marks. 
            // Choosing a button, its image will be shown in the image box.

                label = "Center";
                :row{
                    :radio_column{
                        key = "cen_mark";
                        :radio_button{
                            label = "&Mark";
                            key = "cen_mk";
                        }
                        :radio_button{
                            label = "&Line";
                            key = "cen_ln";
                        }
                        :radio_button{
                            label = "N&one";
                            key = "cen_no";
                        }
                    }
                    :image_button{
                        color                   = 0;
                        width                   = 11;
                        aspect_ratio            = 0.8;
                        fixed_height            = true;
                        fixed_width             = true;
                        alignment = centered;
                        key = "cen_icon"; 
                    }
                }
                :spacer { height = 0.1; }
                :edit12_box{
                    label = "Si&ze: ";
                    key = "cen";
                }
            }
        }
    }
    :boxed_column{
        label = "Scale";
        :row{
            :column{
                :edit12_box{
                    fixed_width = true;
                    label = "O&verall Scale: ";
                    key = "gdscl";
                }
                :spacer{ height = 0.1; }
            }
            :toggle{
                label = "Scale to &Paper Space";
                key = "pspace";
            }
        }
    }
    ok_cancel_help_errtile_too;
}

//
//  Dimension Text Location Subdialog
//

ddimx_txtloc :dialog{
    label = "Format";
    fixed_height = true;
    :row{
        :column{
            :column{
                :spacer{ height = 0.3; }
                :toggle{
                    label = "&User Defined";
                    key = "jus";
                }
                :toggle{
                    label = "Force &Line Inside";
                    key = "tofl";
                }
                :text {
                        label = "&Fit: ";

                }
                :popup_list{
                    key = "jfit";
                    list = "Text and Arrows\nText Only\nArrows Only\nBest Fit\nLeader\nNo Leader";
                }
                :spacer{ height = 0.5; }
            }
            :boxed_column{
            //
            // This is boxed column for Justification.
            //
                label = "Horizontal Justification";
                fixed_height = true;
                height = 6.5;
                :spacer{ height = 0.2; }
                :image_button{
                    color                   = 0;
                    width                   = 11;
                    aspect_ratio            = 0.8;
                    fixed_height            = true;
                    fixed_width             = true;
                    alignment = centered;
                    key = "horjust_icon"; 
                }
                :spacer{ height = 0.2; }
                :popup_list{
                    key = "horjust";
                    /*list now in DDIM_C_25..29, was DDIM_DCL_59*/
                }
                :spacer{ height = 0.2; }
            }
        }
        :column{
            :boxed_column{
                label = "Text";
                fixed_height = true;
                :image_button{
                    color                   = 0;
                    width                   = 11;
                    aspect_ratio            = 0.8;
                    fixed_height            = true;
                    fixed_width             = true;
                    alignment = centered;
                    key = "tioh_icon"; 
                }
                :row{
                    fixed_width = true;
                    :spacer{ width = 0.5; }
                    :column{
                        fixed_height = true;
                        :spacer{ height = 0.2; }
                        :toggle{
                            label = "&Inside Horizontal";
                            key = "tih";
                        }
                        :toggle{
                            label = "&Outside Horizontal";
                            key = "toh";
                        }
                    }
                }
            }
            :boxed_column{

            // This is Vertical Justification. 
            // Choose one, then highlight the related image box. 
            // Conversely you can choose a image box, then highlight 
            // the pull down list item.

                label = "Vertical Justification";
                fixed_height = true;
                height = 6.5;
                :spacer{ height = 0.2; }
                :image_button{
                    color                   = 0;
                    width                   = 11;
                    aspect_ratio            = 0.8;
                    fixed_height            = true;
                    fixed_width             = true;
                    alignment = centered;
                    key = "tad_icon"; 
                }
                :spacer{ height = 0.2; }
                :popup_list{
                    key = "tad";
                    list = "Centered \nAbove \nOutside \nJIS";
                }
                :spacer{ height = 0.2; }
            }
        }
    }
    :spacer{ height = 0.2; }
    ok_cancel_help_errtile;
}

//
//  Dimension Annotation Subdialog
//

ddimx_annotation :dialog{
    label = "Annotation";
    fixed_width = true;
    :row{
        :column{
            :boxed_column{
        
        // This is boxed column for Dimension units.
        // The 'Units' button opens another subdialog called 'ddimx_units'.
        // This part is for the primary units.

                label = "Primary Units";
                :row{
                    :button{
                        fixed_width = true;
                        label = "&Units...";
                        key = "annot_unitsp";
                    }
                }
                :edit_box{
                    label = "&Prefix: ";
                    key = "post_1";
                    edit_width = 12;
                    edit_limit = 91;
                }
                :edit_box{
                    label = "&Suffix: ";
                    key = "post_2";
                    edit_width = 12;
                    edit_limit = 105;
                }
                :icon_image{
                    color                   = 0;
              //      width                   = 14;
                    height = 2;
                    aspect_ratio            = 0.45;
                    fixed_height            = true;
                    fixed_width             = true;
                    alignment = right;
                    key = "post_icon1"; 
                    allow_accept = false;
                }
            }
            :boxed_column{
            //
            // This is boxed portion for Tolerance.
            //
                label = "Tolerance";
                :popup_list{
                    label = "&Method: ";
                    key = "toltypes";
                    list = "None \nSymmetrical \nDeviation \nLimits \nBasic";
                    edit_width = 16;
                }
                :edit12_box{
                    label = "Upper &Value: ";
                    key = "tp";
                }
                :edit12_box{
                    label = "Lo&wer Value: ";
                    key = "tm";
                }
                :popup_list{
                    label = "&Justification: ";
                    key = "tolj";
                    list = "Top \nMiddle \nBottom";
                    edit_width = 10;
                }
                :edit12_box{
                    label = "He&ight: ";
                    key = "tfac";
                }
            }
            :spacer{ height = 0.1; }
        }
        :column{
            :boxed_column{

            // This is boxed column for alternate dimunits.
            // The 'Units' button opens another subdialog 'ddimx_units',
            // but this one is for Alternate Units and the values in
            // ddimx_units subdialog are of the alternate units. It is
            // different from the stuff for the primary units.

                label = "Alternate Units";
                key = "alts";
                :row{
                    :toggle{
                        label = "&Enable Units";
                        key = "alt";
                    }
                    :button{
                        fixed_width = true;
                        label = "U&nits...";
                        key = "annot_unitsa";
                    }
                }
                :column{
                    key = "apost";
                    :edit_box{
                        label = "Pre&fix: ";
                        key = "apost_1";
                        edit_width = 12;
                        edit_limit = 91;
                    }
                    :edit_box{
                        label = "Suffi&x: ";
                        key = "apost_2";
                        edit_width = 12;
                        edit_limit = 105;
                    }
                    :icon_image{
                        color                   = 0;
                //        width                   = 14;
                        height = 2;
                        aspect_ratio            = 0.45;
                        fixed_height            = true;
                        fixed_width             = true;
                        alignment = right;
                        key = "post_icon2"; 
                        allow_accept = false;  
                  }
                }
            }
            :boxed_column{
                label = "Text";
                :popup_list{
                    label = "Sty&le: ";
                    key = "txsty";
                    edit_witdh = 31;
                    list = "";
                }
                :edit12_box{
                    label = "Heigh&t: ";
                    key = "txt";
                }
                :edit12_box{
                    label = "&Gap: ";
                    key = "gap";
                }

                ddimx_colort;
            }
            :edit12_box{
                label = "&Round Off:";
                key = "rnd";
            }
            :spacer{ height = 0.2; }
        }
    }
    ok_cancel_help_errtile_too;
}

//
//  Dimension Units Subdialog - This is called by Annotation dialog.
//                              There are two calling cases, one for 
//                              the primary units and another is for
//                              the alternate units.
//

ddimx_unitsp :dialog{
    label = "Primary Units";
    fixed_width = true;

    units_list;
    units_ufac;

    ok_cancel_help_errtile_too;
}


ddimx_unitsa :dialog{
    label = "Alternate Units";
    fixed_width = true; 

    units_list;
    units_ufac;

    ok_cancel_help_errtile_too;
}

units_ufac :column{
    :boxed_row{
        label = "Scale";
        :column{
            :edit12_box{
                label = "Linea&r: ";
                key = "ufac";
            }
            :spacer{ height = 0.2; }
        }
        :spacer { width = 5; }
        :toggle{
            label = "Paper &Space Only";
            key = "psufac";
        }
    }
}

units_list :column{
    //
    // Horizontal cluster that contains the Units and Angles clusters.
    //
        //
        // Units cluster.
        //
    :row{
        : boxed_column {
            width = 24;
            label = "&Units";
            //
            // Radio cluster for the units format selection.
            //
            : popup_list {
                key = "u_list";
                list = "Scientific\nDecimal\nEngineering\nArchitectural (stacked)\nFractional (stacked)\nArchitectural\nFractional\nWindows Desktop";
            }
            :spacer{ height = 0.2; }
        }
        //
        // Angle Formats Control.
        //
        : boxed_column {
            width = 24;
            label = "&Angles";
            //
            // Radio cluster for the angle format selection.
            //
            : popup_list {
                key = "u_alist";
                list = "Decimal Degrees \nDeg/Min/Sec \nGrads \nRadians \nSurveyor";
            }
            :spacer{ height = 0.2; }
        }
    }
    :row{
        :boxed_column{
            label = "Dimension";
            //
            // Linear Units Precision popup_list (System variable LUPREC).
            //
            : text {
                label = "&Precision:";
            }
            : popup_list {
                key = "u_dimdec";
            }
            :boxed_row{
                label = "Zero Suppression";
                key = "zsuppress";
                :column{
                    :toggle{
                        label = "&Leading";
                        key = "z3";
                    }
                    :toggle{
                        label = "&Trailing";
                        key = "z4";
                    }
                }
                :column{
                    key = "feetinch";
                    :toggle{
                        label = "0 &Feet";
                        key = "z1";
                    }
                    :toggle{
                        label = "0 &Inches";
                        key = "z2";
                    }
                }
            }
        }
        :boxed_column{
            label = "Tolerance";
            //
            // Angle Precision popup_list (system variable AUPREC).
            //
            spacer_0;
            : text {
                label = "Precisi&on:";
            }    
            : popup_list {
                key = "u_toldec";
            }

            :boxed_row{
                label = "Zero Suppression";
                key = "tzsuppress";
                :column{
                    :toggle{
                        label = "Lea&ding";
                        key = "tz3";
                    }
                    :toggle{
                        label = "Traili&ng";
                        key = "tz4";
                    }
                }
                :column{
                    key = "tfeetinch";
                    :toggle{
                        label = "0 F&eet";
                        key = "tz1";
                    }
                    :toggle{
                        label = "0 In&ches";
                        key = "tz2";
                    }
                }
            }
        }
    }
}


//
//  User Arrow subdialog - This is called by Geometry when the user 
//                         selects 'User Arrow' tile.
//                         This dialog allows for the user to set user
//                         arrow head block names.
//

ddimx_userarr :dialog{
    label = "User Arrow";
    fixed_width = true;
    :spacer{ height = 0.3; }
    :edit_box{
        label = "Arrow &Name: ";
        key = "userarr1";
        fixed_width = true;
        allow_accept = true;
        alignment = centered;
        edit_width = 12;
        edit_limit = 217;
    }
    :spacer{ height = 0.5; }
    ok_cancel_help_errtile;
}

//==========================================================
//    'rq_chroma:dialog{}' must be present here because DDIM.DCL
//    can not share the same dcl function defined in ACAD.DCL since
//    DDIM has been separated from ACAD.DCL.
//    

// The standard color selection dialogue comes to ADS
// The meat of the dialogue is defined in base.dcl and used here and in
//    acad.dcl.

rq_chroma :dialog {
    label = "Select Color";
    key = "chroma";                   // used by Help button to obtain label
    initial_focus = "color_edit";
    std_rq_color;
}

ok_cancel_help_errtile_too : column {
    :row {
        errtile;
        ok_cancel_help;
    }
}

// ==== End of the DDIMX dialogs portion ====

