// Next available MSG number is    36 
// MODULE_ID DDSELECT_DCL_
/* Next available MSG number is  35 */

//----------------------------------------------------------------------------
//
//   DDSELECT.DCL   Version 1.0
//
//     Copyright 1991, 1992, 1993, 1994, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//. 
//----------------------------------------------------------------------------

//dcl_settings : default_dcl_settings { audit_level = 3; }

ddselect : dialog {
    label = "Object Selection Settings";
    : boxed_column {
        label = "Selection Modes";
        : toggle {
            label = "Noun/Verb Selection";
            key = "pickfirst";
            mnemonic = "N";
            fixed_width = true;
        }
        : toggle {
            label = "Use Shift to Add";
            key = "pickadd";
            mnemonic = "U";
            fixed_width = true;
        }
        : toggle {
            label = "Press and Drag";
            key = "pickdrag";
            mnemonic = "P";
            fixed_width = true;
        }
        : toggle {
            label = "Implied Windowing";
            key = "pickauto";
            mnemonic = "I";
            fixed_width = true;
        }
        : toggle {
            label = "Object Grouping";
            key = "grouping";
            mnemonic = "G";
            fixed_width = true;
        }
        : toggle {
            label = "Associative Hatch";
            key = "hatch";
            mnemonic = "A";
            fixed_width = true;
        }
        : button {
            label = "Default";
            key = "default_mode";
            fixed_width = true;
            mnemonic = "D";
            alignment = centered;
        }
    }
    : boxed_row {
        label = "Pickbox Size";
        mnemonic = "S";
        spacer_0;
        : column {
            spacer_0;
            fixed_width = true;
            : text {
                  label = "Min         Max";
                  alignment = centered;
            }
            : slider {
                key = "pickbox_slider";
                min_value = 0;
                max_value = 19;
                width = 20;
                height = 1;
                small_increment = 1;
                big_increment = 1;
                fixed_width = true;
                fixed_height = true;
            }
            spacer_0;
        }
        : image {
            key = "pickbox_image";
            aspect_ratio = 1;
            height = 4;
            width = 7;
            color = -2;
        }
        spacer_0;
    }
    : button {
        label = "Object Sort Method...";
        key = "ent_sort";
        mnemonic = "E";
        fixed_width = true;
        alignment = centered;
    }
    ok_cancel_help;
}

sortents : dialog {
    label = "Object Sort Method";
    : text {
        label = "Sort Objects for";
    }
    : toggle {
        label = "Object Selection";
        key = "sort_obj_sel";
        mnemonic = "O";
        fixed_width = true;
    }
    : toggle {
        label = "Object Snap";
        key = "sort_obj_snap";
        mnemonic = "S";
        fixed_width = true;
    }
    : toggle {
        label = "Redraws";
        key = "sort_redraws";
        mnemonic = "R";
        fixed_width = true;
    }
    : toggle {
        label = "Regens";
        key = "sort_regens";
        mnemonic = "e";
        fixed_width = true;
    }
    : toggle {
        label = "Plotting";
        key = "sort_plot";
        mnemonic = "P";
        fixed_width = true;
    }
    : toggle {
        label = "PostScript Output";
        key = "sort_post";
        mnemonic = "c";
        fixed_width = true;
    }
    ok_cancel;
}
