// Next available MSG number is   181 
// MODULE_ID HPMPLWIN_DCL_
mainmenu: dialog {
    label = "HP Plotter Configuration";
    alignment = centered;
    initial_focus = "accept";
    : boxed_row {
        key=  "modellabel";
        label = "Current device configuration:";
                :text {
                    key=  "idmodel";
                }
                : button {
                    label = "Hints...";
                    key = "DevHints";
                    mnemonic = "i";
                    fixed_width = true;
                }
        }

    : boxed_column {
        label = "Memory configuration:";
        key =  "MemCfg";
        : row {
            : toggle {
                label = "Optimize memory usage";
                key = "OptimizeMem";
                mnemonic = "u";
            }
            : concatenation {
                : edit_box {
                    label = "Plotter memory:";
                    key = "PlotMem";
                    mnemonic = "m";
                    alignment = right;
                    edit_width = 3;
                    edit_limit = 3;
                }
                : text_part {
                    label = "Mb";
                    key = "PlotMemUnits";
                }
            }
            : button {
                label = "Hints...";
                key = "MemHints";
                mnemonic = "i";
                fixed_width = true;
            }
        }
    }

    : boxed_column {
        label = "Plot configuration:";
        key =  "UserCfg";
        : row {
            : column {  // Begin Left Column
                : boxed_radio_column {
                    label = "Quality";
                    key   = "qual";
                    : radio_button {
                        label = "Fast \/ Draft";
                        key = "draft";
                        mnemonic = "F";
                    }
                    : radio_button {
                        label = "Normal \/ Final";
                        key = "final";
                        mnemonic = "r";
                        value = "1";
                    }
                    : radio_button {
                        label = "Best \/ Enhanced";
                        key = "enhanced";
                        mnemonic = "E";
                    }
                    : radio_button {
                        label = "Plotter Default";
                        key = "pldefault";
                        mnemonic = "D";
                    }
                }  // End radio_column (Print Qual) //
            }  // End Left Column
            : column {  // Begin Middle Column
                : edit_box {
                    label = "Number of Copies:";
                    mnemonic = "N";
                    key = "copies";
                    edit_width = 2;
                    edit_limit = 2;
                    fixed_width=true;
                }
                : boxed_radio_column {
                    label = "Print colors";
                    key   = "color_set";
                    : radio_button {
                        label = "In color";
                        key = "pcolor";
                        mnemonic = "c";
                    }
                    : radio_button {
                        label = "Colors as gray";
                        key = "pgray";
                        mnemonic = "g";
                    }
                    : radio_button {
                        label = "All as black";
                        key = "pblack";
                        mnemonic = "b";
                    }
                } //end of color setting
            }
            : column {  
                // Begin Right Column
                : button {
                    label = "Pens...";
                    mnemonic = "P";
                    key = "penattr";
                }
                : button {
                    label = "Annotations...";
                    mnemonic = "A";
                    key = "annotate";
                }
                : button {
                    label = "Media Orientation...";
                    mnemonic = "O";
                    key = "paper";
                }
                : button {
                    label = "Advanced Media Opt...";
                    mnemonic = "v";
                    key = "advopt";
                }
            }  // End Right Column
        }  // End Row of two columns

    } // End "User config

    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            key = "helpmain";
            mnemonic = "H";
            width = 12;
        }
        : spacer {
            width = 2;
        }
        : button {
            label = "About...";
            key = "about";
            mnemonic = "A";
            width = 12;
        }
    }
}  // End MAIN MENU Dialog //

//      PENATTR.DCL
//      Dialog Box for setting attributes for pens
//
penattr: dialog {
    label = "Pens";
    initial_focus = "accept";
    fixed_height = true;
    : row {  // Pen
        : column {
            : popup_list {
                label = "Pen (1..255):";
                mnemonic = "P";
                fixed_width = true;
                key = "slider";
                edit_width = 4;
            }
            : button {
                label = "Apply to All Pens";
                mnemonic = "A";
                key = "okall";
            }
        }  // End Pen Column
        : column {
            : boxed_row {
                label = "Plot Merge Control";
                : radio_column {  // Merge
                    key = "mc";
                    fixed_height = true;
                    : radio_button {
                        label = "Lines Overwrite";
                        key = "mc0";
                        mnemonic = "O";
                    }
                    : radio_button {
                        label = "Lines Merge";
                        key = "mc1";
                        mnemonic = "M";
                    }
                }  // End (Merge) column
                : column {
                    fixed_width = true;
                    //fixed_height = true;
                    :image {
                        key = "overw_im";
                        height = 1;
                        aspect_ratio = 1.4;
                    }
                    :image {
                        key = "merge_im";
                        height = 1;
                        aspect_ratio = 1.4;
                    }
                }
                spacer_1;
            } //end merge row
            : button {
                label = "Halftoning...";
                key = "printop";
                mnemonic = "t";
            }
        }
    }

    : row {
        :boxed_row {
            label = "Line End:";
            key = "endlabel";
            mnemonic = "E";
            : image_button {
                key = "end_tile1";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "end_tile2";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "end_tile3";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "end_tile4";
                width = 5;
                aspect_ratio = 0.75;
            }
        }
        :boxed_row {
            label = "Line Join:";
            key = "joinlabel";
            mnemonic = "J";
            : image_button {
                key = "join_tile1";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile2";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile3";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile4";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile5";
                width = 5;
                aspect_ratio = 0.75;
            }
        }
    }  // End Row (Line ends/joins)

    : row { // ( Fills & Raster patterns)
        : boxed_column {  // Fills
            label = "Fill:";
            mnemonic = "F";
            : list_box {
                fixed_height = true;
                height = 5;
                key = "filltype";
            }
            : edit_box {
                fixed_width = true;
                edit_width = 2;
                edit_limit = 2;
                label = "Spacing 1..99mm:";
                key   = "spacing";
                mnemonic = "S";
            }

            : edit_box {
                fixed_width = true;
                edit_width = 3;
                edit_limit = 3;
                label = "Angle 0..359:";
                key   = "angle";
                mnemonic = "g";
            }

            : edit_box {  // Shade
                fixed_width = true;
                edit_width = 2;
                edit_limit = 2;
                label = "Shade 0..99%:";
                key   = "shdpct";
                mnemonic = "d";
            }  // End Shade
        }  // End column (Fills)

        : boxed_column { // Raster patterns
            label = "Raster Patterns:";
            key = "rastpat";
            mnemonic = "R";
            fixed_height = true;
            width = 33;
            : list_box {
                fixed_height = true;
                height = 8;
                key = "patlist";
            }
            : button {
                label = "Change...";
                mnemonic = "C";
                key = "changerast";
            }
        }  // End Column ( Raster Patterns )
    }  // End Row

    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            key = "helppen";
            width = 12;
            mnemonic = "H";
        }
    }

}  // End LINE ATTRIBUTES Dialog //

//      PENPPENATTR.DCL
//      Dialog Box for setting attributes for pens
//
penppenattr: dialog {
    label = "Pens";
    initial_focus = "accept";
    fixed_height = true;
    : row {  // Pen
        : column {
            : popup_list {
                label = "Pen (1..255):";
                mnemonic = "P";
                fixed_width = true;
                key = "slider";
                edit_width = 4;
            }
            : button {
                label = "Apply to All Pens";
                mnemonic = "A";
                key = "okall";
            }
        }  // End Pen Column
        : column {
            : boxed_row {
                label = "Generate Area Fills in:";
                : radio_column {  // SFILLS
                    key = "sfills";
                    fixed_height = true;
                    : radio_button {
                        label = "Plotter (Best Lockout Time)";
                        key = "sfillspl";
                        mnemonic = "l";
                    }
                    : radio_button {
                        label = "AutoCAD (Best Plotting Time)";
                        key = "sfillsacad";
                        mnemonic = "D";
                    }
                }  // End (Merge) column
            } //end merge row
        }
    }

    : row {
        :boxed_row {
            label = "Line End:";
            key = "endlabel";
            : image_button {
                key = "end_tile1";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "end_tile2";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "end_tile3";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "end_tile4";
                width = 5;
                aspect_ratio = 0.75;
            }
        }
        :boxed_row {
            label = "Line Join:";
            key = "joinlabel";
            : image_button {
                key = "join_tile1";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile2";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile3";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile4";
                width = 5;
                aspect_ratio = 0.75;
            }
            : image_button {
                key = "join_tile5";
                width = 5;
                aspect_ratio = 0.75;
            }
        }
    }  // End Row (Line ends/joins)

    : row { // ( Fills & Raster patterns)
        key = "fillsdef";
        : boxed_column {  // Fills
            label = "Fill:";
            : list_box {
                fixed_height = true;
                height = 5;
                key = "filltype";
            }
            : edit_box {
                fixed_width = true;
                edit_width = 2;
                edit_limit = 2;
                label = "Spacing 1..99mm:";
                key   = "spacing";
                mnemonic = "S";
            }

            : edit_box {
                fixed_width = true;
                edit_width = 3;
                edit_limit = 3;
                label = "Angle 0..359:";
                key   = "angle";
                mnemonic = "g";
            }

            : edit_box {  // Shade
                fixed_width = true;
                edit_width = 2;
                edit_limit = 2;
                label = "Shade 0..99%:";
                key   = "shdpct";
                mnemonic = "h";
            }  // End Shade
        }  // End column (Fills)

        : boxed_column { // Raster patterns
            key = "rastpat";
            label = "Raster Patterns:";
            fixed_height = true;
            width = 33;
            : list_box {
                fixed_height = true;
                height = 8;
                key = "patlist";
            }
            : button {
                label = "Change...";
                mnemonic = "C";
                key = "changerast";
            }
        }  // End Column ( Raster Patterns )
    }  // End Row

    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            key = "helppen";
            width = 12;
            mnemonic = "H";
        }
    }

}  // End LINE ATTRIBUTES Dialog //

//  ANNOTATE.DCL
//  Menu for annotating plot-time variables into left side of plot
//

annotate: dialog {
    label = "Annotations";
    initial_focus = "accept";
    : row  { // of two columns
        : column {
            : toggle {
                label = "Drawing Filename";
                key = "dwgname";
                mnemonic = "F";
            }
            : toggle {
                label = "Plot Date/Time";
                key = "plottime";
                mnemonic = "T";
            }
        }  // End column (dwgname, plottime)
        : column {
            : toggle {
                label = "Driver Info";
                key = "dvrname";
                mnemonic = "I";
            }
            : toggle {
                label = "Crop Marks";
                key = "cropmarks";
                mnemonic = "M";
            }
        }  // End column ( drvname, cropmarks )
    }  // End row of 2 columns

    : column {
        : text {
            key = "commentlabel";
            label = "Comments: (50 Characters Max)";
            mnemonic = "C";
        }
        : edit_box {
            key = "comment";
            width = 51;
            edit_limit = 50;
        }
    }  // End Comment column

    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            key = "helpanno";
            mnemonic = "H";
            width = 12;
        }
    }

}  // End PLOT ANNOTATE Dialog //


//  HELP DIALOG
//  The help dialog is popped up to display a help message based
//  on which "screen" the user was interacting with when he
//  depressed the help button

help: dialog {
    label = "Help/Info";
    initial_focus = "accept";
    : list_box {
        width = 55;
        height = 16;
        key = "helplist";
    }
    : retirement_button {
        label = "OK";
        key = "accept";
        is_default = true;
        is_cancel = true;
    }
}  // End HELP Dialog

//  OKALLPENS DIALOG
okallpens: dialog {
    fixed_width = true;
    alignment = centered;
    label = "!! CAUTION !!";
    initial_focus = "accept";
    : text {
        label = "OK to apply settings to ALL pens?";
        key = "askok";
    }
    : row {
        alignment = centered;
        : retirement_button {
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
    }  // End row
}  // End OKALLPENS Dialog //

GenericOrient : dialog {
    label = "Media Options";
    initial_focus = "accept";
    : boxed_row {
        label = "Click on Match for Your Image and Media";
        mnemonic = "C";
        fixed_width = true;
        fixed_height = true;
        spacer_0;
        : column {
            fixed_width = true;
            fixed_height = true;
            : image_button {
                key = "image1";
                width = 14;
                aspect_ratio = 0.65;
            }
            : image_button {
                key = "image3";
                width = 14;
                aspect_ratio =0.65;
            }
            : image_button {
                key = "image5";
                width = 14;
                aspect_ratio =0.65;
            }
            : image_button {
                key = "image7";
                width = 14;
                aspect_ratio = 0.65;
            }
        }
        spacer_0;
        : column {
            fixed_width = true;
            fixed_height = true;
            : image_button {
                key = "image2";
                width = 14;
                aspect_ratio = 0.65;
            }
            : image_button {
                key = "image4";
                width = 14;
                aspect_ratio = 0.65;
            }
            : image_button {
                key = "image6";
                width = 14;
                aspect_ratio = 0.65;
            }
            : image_button {
                key = "image8";
                width = 14;
                aspect_ratio = 0.65;
            }
        }
        spacer_0;
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {   
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            mnemonic = "H";
            key = "helppaper";
        }
    }  // End Row;
}


BandingOrient : dialog {
    label = "Media Options";
    initial_focus = "accept";
    : boxed_row {
        label = "Click on Match for Your Image and Media";
        mnemonic = "C";
        fixed_width = true;
        fixed_height = true;
        spacer_0;
        : column {
            fixed_width = true;
            fixed_height = true;
            : image_button {
                key = "image1";
                width = 14;
                aspect_ratio = 0.65;
            }
            : image_button {
                key = "image7";
                width = 14;
                aspect_ratio = 0.65;
            }
        }
        spacer_0;
        : column {
            fixed_width = true;
            fixed_height = true;
            : image_button {
                key = "image6";
                width = 14;
                aspect_ratio = 0.65;
            }
            : image_button {
                key = "image8";
                width = 14;
                aspect_ratio = 0.65;
            }
        }
        spacer_0;
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {   
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            mnemonic = "H";
            key = "helppaper";
        }
    }  // End Row;
}


paperadv : dialog {
    label = "Advanced Media Options";
    initial_focus = "accept";
    : boxed_row {
        label = "Select level of control for plotter margins";
        : boxed_radio_column {
            label = "If Scaled to Fit is OFF";
            key = "sclmarginadj";
            : radio_button {
                label = "Display clip warnings";
                key = "sclwarnings";
                mnemonic = "w";
            }
            : radio_button {
                label = "Don't display warnings";
                key = "scldisabled";
                mnemonic = "D";
            }
        }
        : boxed_radio_column {
            label = "If Scaled to Fit is ON";
            key = "marginadj";
            : radio_button {
                label = "Don't clip. Adjust to media";
                key = "adjust";
                mnemonic = "A";
            }
            : radio_button {
                label = "Display clip warnings";
                key = "warnings";
                mnemonic = "w";
            }
            : radio_button {
                label = "Don't display warnings";
                key = "disabled";
                mnemonic = "D";
            }
        }
    }
    : boxed_column {
        label = "Plotter Margins";
        : radio_row {
            key = "expand";
            : radio_button {
                label = "Expand OFF";
                key = "expoff";
                mnemonic = "F";
            }
            : radio_button {
                label = "Expand ON";
                key = "expon";
                mnemonic = "N";
            }
        }
        : text {
            label = "Must correspond to plotter setting";
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {   
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            mnemonic = "H";
            key = "helpadv";
        }
    }  // End Row;
    : text {
        key = "errortext";
        width = 55;
    }
}

printops : dialog {
    label = "Halftoning";
    initial_focus = "accept";
    : text {
        centered = true;
        label = "(Only for vectors)";
    }
    : row {
        : radio_column {
            key = "dither";
            : radio_button {
                label = "Scatter";
                key = "scatter";
                mnemonic = "S";
            }
            : radio_button {
                label = "Pattern";
                key = "pattern";
                mnemonic = "P";
            }
            : radio_button {
                label = "Plotter default";
                key = "default";
                mnemonic = "d";
            }
        }
        : column {
            fixed_width = true;
            fixed_height = true;
            : image {
                key = "sc_im";
                height = 1;
                aspect_ratio = 6;
            }
            : image {
                key = "pt_im";
                height = 1;
                aspect_ratio = 6;
            }
            spacer_1;
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : retirement_button {   
            label = "OK";
            key = "accept";
            width = 12;
            is_default = true;
        }
        : retirement_button {
            label = "Cancel";
            key = "cancel";
            width = 12;
            is_cancel = true;
        }
        : button {
            label = "Help...";
            mnemonic = "H";
            key = "helpprintop";
        }
    }  // End Row;
}

aboutmsg : dialog {
    label = "About";
    width  = 64;
    : text {
        key = "DriverVersion";
        alignment = centered;
    }
    : text {
        key = "AboutHeaderKey";
        alignment = centered;
    }
    : list_box {
        fixed_height = true;
        height = 12;
        key =  "AboutKey";
    }
    : button {
        label = "OK";
        key = "accept";
        fixed_width = true;
        alignment = centered;
        width = 12;
        is_default = true;
    }
}
